#include <unistd.h>
#include <sys/stat.h>
#include <conio.h>
#include <stdio.h>
#include <string.h>
#include <allegro.h>
#include "edop.h"
#include "ymw.h"
#include "FileIO.h"
#include "Import.h"
#include "mem.h"
#include "gfxhelp.h"
#include "genproc.h"
#include "ColorPicker.h"
#include "MainDialog.h"
#include "ObjectDialog.h"
#include "MobileDialog.h"
#include "ShopDialog.h"
#include "ContentDialog.h"
#include "VersionDialog.h"
#include "StatsDialog.h"
#include "find.h"
#include "lists.h"
#include "SpellCheck.h"
#include "RegistrarDialog.h"

int d_stat_line_proc( int msg, DIALOG *d, int c );
void quick_do_dir( int setto );
int quick_do_north();
int quick_do_east();
int quick_do_south();
int quick_do_west();
int quick_do_up();
int quick_do_down();
int quick_do_none();
int tagview_check_proc( int msg, DIALOG *d, int c );
int coasterview_check_proc( int msg, DIALOG *d, int c );
int transview_check_proc( int msg, DIALOG *d, int c );
char *room_cont_lister( int index, int *list_size );
int room_cont_list_proc( int msg, DIALOG *d, int c );
void udisp( int id );
int wrld_save_as();
int wrld_save();
int wrld_load();
int wrld_export();
int wrld_blank();
int temp_text_deal();
int do_exit();
int d_mledit_proc(int msg, DIALOG *d, int c);
int d_myedit_proc( int msg, DIALOG *d, int c );
char *rbv_lister(int index, int *list_size);
int rbv_list_proc( int msg, DIALOG *d, int c );
int oppdir( int dir );
int del_this_door();
void do_door_keyword_dlg();
int d_door_setter( int msg, DIALOG *d, int c );
int del_this_room();
void tag_prop( int index );
int d_ed_box( int msg, DIALOG *d, int c );
char *stype_lister(int index, int *list_size);
int stype_list_proc( int msg, DIALOG *d, int c );
int zone_list_proc( int msg, DIALOG *d, int c );
char *zone_lister( int index, int *list_size );
char *rexd_lister( int index, int *list_size );
void do_rexd_prop_dlg( int index );
int rexd_list_proc( int msg, DIALOG *d, int c );
char *zrbv_lister(int index, int *list_size);
int zrbv_list_proc( int msg, DIALOG *d, int c );
char *zstype_lister(int index, int *list_size);
int zstype_list_proc( int msg, DIALOG *d, int c );
int hue_selector_proc( int msg, DIALOG *d, int c );
int reset_mode_drop_proc( int msg, DIALOG *d, int c );
int do_zone_prop_dlg( char edit, int index );
int d_splash_proc( int msg, DIALOG *d, int c );
int d_draggy_proc( int msg, DIALOG *d, int c );
int do_splash();
int do_refresh();
int dtype_unrestr();
int dtype_normal();
int dtype_pickpro();
int dstate_opened();
int dstate_closed();
int dstate_locked();
char *key_lister( int index, int *list_size ); /* This one is really in ObjectDialog.c, we're just borrowing it... */
int do_door_key_picker_dlg();
int d_door_key_picker_proc( int msg, DIALOG *d, int c );
int do_spell_check();
int dtype_twoway();
int dtype_oneout();
int dtype_onein();
int wrld_bmp_export();
int wrld_import();
int copy_room();
int do_server_clean();
int do_world_run();
int quick_do_door_orient();

MENU menu_file[]=
{
   /* text,                     proc,           child,      flags, dp */
    { "&Save\t(Ctrl+S)",        wrld_save,      NULL,       0,     NULL },
    { "Save &As\t(Ctrl+A)",     wrld_save_as,   NULL,       0,     NULL },
    { "&Load\t(Ctrl+L)",        wrld_load,      NULL,       0,     NULL },
    { "&New\t(Ctrl+N)",         wrld_blank,     NULL,       0,     NULL },
    { "",                       NULL,           NULL,       0,     NULL },
    { "E&xit\t(Ctrl+X)",        do_exit,        NULL,       0,     NULL },
    { NULL,                     NULL,           NULL,       0,     NULL }
};

MENU menu_special_export[]=
{
   /* text,                     proc,           child,      flags, dp */
    { "&YFMud World\t(Ctrl+E)", wrld_export,    NULL,       0,     NULL },
    { "&Bitmaps (BMP)",         wrld_bmp_export,NULL,       0,     NULL },
    { NULL,                     NULL,           NULL,       0,     NULL }
};

MENU menu_special_import[]=
{
   /* text,                     proc,           child,      flags, dp */
    { "&CircleMUD World",       wrld_import,    NULL,       0,     NULL },
    { NULL,                     NULL,           NULL,       0,     NULL }
};

MENU menu_special[]=
{
   /* text,                     proc,           child,      flags, dp */
    { "S&pell Check",           do_spell_check, NULL,       0,     NULL },
    { "&Clean up server",       do_server_clean,NULL,       0,     NULL },
    { "&Run world",             do_world_run,   NULL,       0,     NULL },
    { "&Export to...",          NULL,   menu_special_export,0,     NULL },
    { "&Import from...",        NULL,   menu_special_import,0,     NULL },
    { NULL,                     NULL,           NULL,       0,     NULL }
};

MENU menu_edit[]=
{
   /* text,                     proc,           child,      flags, dp */
    { "&Objects\t(Ctrl+O)",     obj_ed,         NULL,       0,     NULL },
    { "&Mobiles\t(Ctrl+B)",     mob_ed,         NULL,       0,     NULL },
    { "&Shops\t(Ctrl+H)",       shp_ed,         NULL,       0,     NULL },
    { NULL,                     NULL,           NULL,       0,     NULL }
};

MENU menu_misc[]=
{
   /* text,                     proc,           child,      flags, dp */
    { "&Stats",                 do_stat_dlg,    NULL,       0,     NULL },
    { "&Version",               do_ver_dlg,     NULL,       0,     NULL },
    { "S&plash",                do_splash,      NULL,       0,     NULL },
    { "&Refresh",               do_refresh,     NULL,       0,     NULL },
    { "&Text mode",             temp_text_deal, NULL,       0,     NULL },
    { "R&egistration",        do_registrar_dlg, NULL,       0,     NULL },
    { NULL,                     NULL,           NULL,       0,     NULL }
};

MENU menu_root[]=
{
   /* text,             proc,           child,        flags, dp */
    { "&File",          NULL,           menu_file,    0,     NULL },
    { "&Edit",          NULL,           menu_edit,    0,     NULL },
    { "&Special",       NULL,           menu_special, 0,     NULL },
    { "&Misc",          NULL,           menu_misc,    0,     NULL },
    { NULL,             NULL,           NULL,         0,     NULL }
};

MENU room_cont_menu[]=
{
   /* text,               proc,           child,      flags, dp */
    { "&Add new",         NULL,           NULL,       0,     NULL },
    { "&Edit",            NULL,           NULL,       0,     NULL },
    { "&Remove",          NULL,           NULL,       0,     NULL },
    { NULL,               NULL,           NULL,       0,     NULL }
};

MENU menu_dtype[]=
{
   /* text,                     proc,             child,      flags, dp */
    { "Unrestricted passage",   dtype_unrestr,    NULL,       NULL,  NULL },
    { "Normal door",            dtype_normal,     NULL,       NULL,  NULL },
    { "Pickproof door",         dtype_pickpro,    NULL,       NULL,  NULL },
    { "",                       NULL,             NULL,       NULL,  NULL },
    { "Two-way (normal)",       dtype_twoway,     NULL,       NULL,  NULL },
    { "One-way out",            dtype_oneout,     NULL,       NULL,  NULL },
    { "One-way in",             dtype_onein,      NULL,       NULL,  NULL },
    { NULL,                     NULL,             NULL,       NULL,  NULL }
};

MENU menu_dstate[]=
{
   /* text,                     proc,             child,      flags, dp */
    { "Opened",                 dstate_opened,    NULL,       NULL,  NULL },
    { "Closed",                 dstate_closed,    NULL,       NULL,  NULL },
    { "Closed && Locked",       dstate_locked,    NULL,       NULL,  NULL },
    { NULL,                     NULL,             NULL,       NULL,  NULL }
};

MENU menu_door[]=
{
   /* text,                     proc,                     child,      flags, dp */
    { "&Change orientation",    NULL,                     NULL,       0,     NULL },
    { "&Reconnect",             NULL,                     NULL,       0,     NULL },
    { "&Type",                  NULL,                     menu_dtype, 0,     NULL },
    { "&State",                 NULL,                     menu_dstate,0,     NULL },
    { "Choose &Key",            do_door_key_picker_dlg,   NULL,       0,     NULL },
    { "&Delete",                del_this_door,            NULL,       0,     NULL },
    { "&Keywords",              NULL,                     NULL,       0,     NULL },
    { NULL,                     NULL,                     NULL,       0,     NULL }
};

MENU menu_room[]=
{
   /* text,                     proc,                     child,      flags,          dp */
    { "&Delete\t(Del)",         del_this_room,            NULL,       0,              NULL },
    { "&Copy",                  copy_room,                NULL,       0,              NULL },
    { NULL,                     NULL,                     NULL,       0,              NULL }
};

MENU menu_no_room[]=
{
   /* text,                     proc,             child,      flags,          dp */
    { "Create &room\t(Ins)",    NULL,             NULL,       0,              NULL },
    { "Create &tag",            NULL,             NULL,       0,              NULL },
    { "&Center map",            NULL,             NULL,       0,              NULL },
    { "",                       NULL,             NULL,       0,              NULL },
    { "Paste",                  NULL,             NULL,       0,              NULL },
    { NULL,                     NULL,             NULL,       0,              NULL }
};

MENU tag_on_map_menu[]=
{
   /* text,                     proc,             child,      flags,          dp */
    { "&Delete",                NULL,             NULL,       0,              NULL },
    { "&Change text",           NULL,             NULL,       0,              NULL },
    { NULL,                     NULL,             NULL,       0,              NULL }
};

MENU stype_menu[]=
{
   /* text,                     proc,             child,      flags,          dp */
    { "Change color",           NULL,             NULL,       0,              NULL },
    { NULL,                     NULL,             NULL,       0,              NULL }
};

MENU menu_zone_list[]=
{
   /* text,                     proc,           child,      flags, dp */
    { "&Create new",            NULL,           NULL,       0,     NULL },
    { "&Select",                NULL,           NULL,       0,     NULL },
    { "&Properties",            NULL,           NULL,       0,     NULL },
    { "&Delete",                NULL,           NULL,       0,     NULL },
    { "&Move to this zone",     NULL,           NULL,       0,     NULL },
    { NULL,                     NULL,           NULL,       0,     NULL }
};

MENU rexd_menu[]=
{
   /* text,             proc,           child,      flags, dp */
    { "&Create new",    NULL,           NULL,       0,     NULL },
    { "&Edit",          NULL,           NULL,       0,     NULL },
    { "&Delete",        NULL,           NULL,       0,     NULL },
    { NULL,             NULL,           NULL,       0,     NULL }
};

MENU reset_mode_menu[]=
{
   /* text,             proc,           child,      flags, dp */
    { "Never   ",       NULL,           NULL,       0,     NULL },
    { "Deserted",       NULL,           NULL,       0,     NULL },
    { "Always  ",       NULL,           NULL,       0,     NULL },
    { NULL,             NULL,           NULL,       0,     NULL }
};

DIALOG main_dlg[]=
{
     /* proc,                    x,   y,   w,   h,   fg,  bg,  key, flags,  d1,         d2, dp,                      dp2,      dp3 */
/*00*/{ d_clear_proc,            0,   0,   640, 480, CBD, CBD, 0,   0,      0,          0,  NULL,                    NULL,     NULL },
/*01*/{ d_menu_proc,             0,   0,   0,   0,   CTX, CFG, 0,   0,      0,          0,  menu_root,               NULL,     NULL },
/*02*/{ d_keyboard_proc,         0,   0,   0,   0,   0,   0,   'q', 0,      0,          0,  do_exit,                 NULL,     NULL },
/*03*/{ d_mledit_proc,           111, 375, 519, 95,  CTX, CFG, 0,D_DISABLED,0,          0,  NULL,                    NULL,     NULL },
/*04*/{ d_door_setter,           6,   375, 100, 95,  CTX, CFG, 0,   0,      0,          0,  NULL,                    NULL,     NULL },
/*05*/{ d_ed_box,                203, 20,  425, 340, CTX, CFG, 0,   0,      0,          0,  NULL,                    NULL,     NULL },
/*06*/{ d_box_proc,              111, 363, 519, 10,  CTX, CFG, 0,   0,      0,          0,  NULL,                    NULL,     NULL },
/*07*/{ d_myedit_proc,           112, 364, 517, 8,   CTX, CFG, 0,   0,      80,         0,  NULL,                    NULL,     NULL },
/*08*/{ rbv_list_proc,           6,   20,  192, 76,  CTX, CFG, 0,   0,      0,          0,  rbv_lister,              NULL,     NULL },
/*09*/{ stype_list_proc,         6,   98,  192, 76,  CTX, CFG, 0,   0,      0,          0,  stype_lister,            NULL,     NULL },
/*10*/{ d_stat_line_proc,        440, 0,   200, 19,  CTX, CBD, 0,   0,      0,          0,  NULL,                    NULL,     NULL },
/*11*/{ d_keyboard_proc,         0,   0,   0,   0,   0,   0,   0,   0,      KEY_8_PAD,  0,  quick_do_north,          NULL,     NULL },
/*12*/{ d_keyboard_proc,         0,   0,   0,   0,   0,   0,   0,   0,      KEY_2_PAD,  0,  quick_do_south,          NULL,     NULL },
/*13*/{ d_keyboard_proc,         0,   0,   0,   0,   0,   0,   0,   0,      KEY_6_PAD,  0,  quick_do_east,           NULL,     NULL },
/*14*/{ d_keyboard_proc,         0,   0,   0,   0,   0,   0,   0,   0,      KEY_4_PAD,  0,  quick_do_west,           NULL,     NULL },
/*15*/{ d_keyboard_proc,         0,   0,   0,   0,   0,   0,   0,   0,      KEY_3_PAD,  0,  quick_do_down,           NULL,     NULL },
/*16*/{ d_keyboard_proc,         0,   0,   0,   0,   0,   0,   0,   0,      KEY_7_PAD,  0,  quick_do_up,             NULL,     NULL },
/*17*/{ zone_list_proc,          6,   176, 192, 44,  CTX, CFG, 0,   0,      0,          0,  zone_lister,             NULL,     NULL },
/*18*/{ d_keyboard_proc,         0,   0,   0,   0,   0,   0,   26,  0,      0,          0,  quick_do_none,           NULL,     NULL },
/*19*/{ d_keyboard_proc,         0,   0,   0,   0,   0,   0,   0,   0,      KEY_DEL,    0,  del_this_room,           NULL,     NULL },
/*20*/{ d_keyboard_proc,         0,   0,   0,   0,   0,   0,   0,   0,      KEY_5_PAD,  0,  quick_do_none,           NULL,     NULL },
/*21*/{ tagview_check_proc,      340, 0,   44,  8,   CTX, CBD, 0,D_SELECTED,1,          1,  "Tags",                  NULL,     NULL },
/*22*/{ coasterview_check_proc,  340, 8,   84,  8,   CTX, CBD, 0,D_SELECTED,1,          1,  "Coasters",              NULL,     NULL },
/*23*/{ rexd_list_proc,          6,   222, 192, 44,  CTX, CFG, 0,   0,      0,          0,  rexd_lister,             NULL,     NULL },
/*24*/{ room_cont_list_proc,     6,   268, 192, 92,  CTX, CFG, 0,   0,      0,          0,  room_cont_lister,        NULL,     NULL },
/*25*/{ transview_check_proc,    230, 0,   110, 8,   CTX, CBD, 0,D_SELECTED,1,          1,  "Transparancy",          NULL,     NULL },
/*26*/{ d_keyboard_proc,         0,   0,   0,   0,   0,   0,   19,  0,      0,          0,  wrld_save,               NULL,     NULL },
/*27*/{ d_keyboard_proc,         0,   0,   0,   0,   0,   0,   0,   0,    KEY_ASTERISK, 0,  quick_do_door_orient,    NULL,     NULL },
/*28*/{ d_keyboard_proc,         0,   0,   0,   0,   0,   0,   12,  0,      0,          0,  wrld_load,               NULL,     NULL },
/*29*/{ d_keyboard_proc,         0,   0,   0,   0,   0,   0,   5,   0,      0,          0,  wrld_export,             NULL,     NULL },
/*30*/{ d_keyboard_proc,         0,   0,   0,   0,   0,   0,   0,   0,    KEY_PLUS_PAD, 0,  quick_do_down,           NULL,     NULL },
/*31*/{ d_keyboard_proc,         0,   0,   0,   0,   0,   0,   0,   0,   KEY_MINUS_PAD, 0,  quick_do_up,             NULL,     NULL },
/*32*/{ d_keyboard_proc,         0,   0,   0,   0,   0,   0,   24,  0,      0,          0,  do_exit,                 NULL,     NULL },
/*33*/{ d_keyboard_proc,         0,   0,   0,   0,   0,   0,   15,  0,      0,          0,  obj_ed,                  NULL,     NULL },
/*34*/{ d_keyboard_proc,         0,   0,   0,   0,   0,   0,   2,   0,      0,          0,  mob_ed,                  NULL,     NULL },
/*35*/{ d_keyboard_proc,         0,   0,   0,   0,   0,   0,   8,   0,      0,          0,  shp_ed,                  NULL,     NULL },
/*36*/{ d_draggy_proc,           197, 12,  6,   6,   CTX, CBD, 0,   0,      40,         600,NULL,                    NULL,     NULL },
/*37*/{ d_splash_proc,           0,   0,   0,   0,   0,   0,   0,   0,      0,          0,  NULL,                    NULL,     NULL },
standarnd_dialog_chunks
};

DIALOG door_keyword_dlg[]=
{
     /* proc,                    x,   y,   w,   h,   fg,  bg,  key, flags,  d1,         d2, dp,              dp2,      dp3 */
/*00*/{ d_shadow_box_proc,       0,   0,   320, 48,  CTX, CFG, 0,   0,      0,          0,  NULL,            NULL,     NULL },
/*01*/{ d_ctext_proc,            160, 2,   0,   0,   CTX, CFG, 0,   0,      0,          0,  "Key Words:",    NULL,     NULL },
/*02*/{ d_edit_proc,             4,   15,  312, 8,   CTX, CBD, 0,   0,      NAMESIZE,   0,  "TempText004",   NULL,     NULL },
/*03*/{ d_button_proc,           120, 30,  80,  15,  CTX, CFG, 0,   D_EXIT, 0,          0,  "Finished",      NULL,     NULL },
standarnd_dialog_chunks
};

DIALOG tag_prop_dlg[]=
{
     /* proc,                    x,   y,   w,   h,   fg,  bg,  key, flags,  d1,         d2, dp,              dp2,      dp3 */
/*00*/{ d_shadow_box_proc,       0,   0,   320, 48,  CTX, CFG, 0,   0,      0,          0,  NULL,            NULL,     NULL },
/*01*/{ d_ctext_proc,            160, 2,   0,   0,   CTX, CFG, 0,   0,      0,          0,  "Text of tag:",  NULL,     NULL },
/*02*/{ d_edit_proc,             4,   15,  312, 8,   CTX, CBD, 0,   0,      NAMESIZE,   0,  "TempText000",   NULL,     NULL },
/*03*/{ d_button_proc,           120, 30,  80,  15,  CTX, CFG, 0,   D_EXIT, 0,          0,  "Finished",      NULL,     NULL },
standarnd_dialog_chunks
};

DIALOG rexd_prop_dlg[]=
{
     /* proc,                    x,   y,   w,   h,   fg,  bg,  key, flags,  d1,         d2, dp,              dp2,      dp3 */
/*00*/{ d_shadow_box_proc,       0,   0,   320, 51,  CTX, CFG, 0,   0,      0,          0,  NULL,            NULL,     NULL },
/*01*/{ d_ctext_proc,            160, 2,   0,   0,   CTX, CFG, 0,   0,      0,          0,  "Room EXD Properties",  NULL,     NULL },
/*02*/{ d_text_proc,             4,   12,  112, 8,   CTX, CFG, 0,   0,      0,          0,  "Keywords:",     NULL,     NULL },
/*03*/{ d_edit_proc,             116, 12,  200, 8,   CTX, CBD, 0,   0,      NAMESIZE,   0,  "TempText001",   NULL,     NULL },
/*04*/{ d_text_proc,             4,   22,  112, 8,   CTX, CFG, 0,   0,      0,          0,  "Description:",  NULL,     NULL },
/*05*/{ d_edit_proc,             116, 22,  200, 8,   CTX, CBD, 0,   0,      RDSIZE,     0,  "TempText002",   NULL,     NULL },
/*06*/{ d_button_proc,           120, 32,  80,  15,  CTX, CFG, 0,   D_EXIT, 0,          0,  "Finished",      NULL,     NULL },
standarnd_dialog_chunks
};

DIALOG zone_prop_dlg[]=
{
     /* proc,                    x,   y,   w,   h,   fg,  bg,  key, flags,  d1,         d2, dp,              dp2,      dp3 */
/*00*/{ d_shadow_box_proc,       0,   0,   320, 161, CTX, CFG, 0,   0,      0,          0,  NULL,            NULL,     NULL },
/*01*/{ d_ctext_proc,            160, 2,   0,   0,   CTX, CFG, 0,   0,      0,          0,  NULL,            NULL,     NULL },
/*02*/{ d_text_proc,             4,   15,  72,  8,   CTX, CFG, 0,   0,      0,          0,  "Name:  ",       NULL,     NULL },
/*03*/{ d_edit_proc,             76,  15,  240, 8,   CTX, CBD, 0,   0,      NAMESIZE,   0,  NULL,            NULL,     NULL },
/*04*/{ d_text_proc,             4,   24,  72,  8,   CTX, CFG, 0,   0,      0,          0,  "Author:  ",     NULL,     NULL },
/*05*/{ d_edit_proc,             76,  24,  240, 8,   CTX, CBD, 0,   0,      NAMESIZE,   0,  NULL,            NULL,     NULL },
/*06*/{ d_text_proc,             4,   33,  72,  8,   CTX, CFG, 0,   0,      0,          0,  "VNUM:  ",       NULL,     NULL },
/*07*/{ d_text_proc,             76,  33,  48,  8,   CTX, CBD, 0,   0,      4,          0,  "-1",            NULL,     NULL },
/*08*/{ d_text_proc,             4,   43,  104, 8,   CTX, CFG, 0,   0,      0,          0,  "Reset Mode:  ", NULL,     NULL },
/*09*/{ reset_mode_drop_proc,    104, 41,  104, 12,  CTX, CFG, 0,   D_EXIT, 0,          0,  "Always   ",     NULL,     NULL },
/*10*/{ d_text_proc,             4,   55,  104, 8,   CTX, CFG, 0,   0,      0,          0,  "Life Span:   ", NULL,     NULL },
/*11*/{ d_edit_proc,             104, 55,  32,  8,   CTX, CBD, 0,   0,      3,          0,  "15 ",           NULL,     NULL },
/*12*/{ d_text_proc,             4,   65,  104, 8,   CTX, CFG, 0,   0,      0,          0,  "Tint color:  ", NULL,     NULL },
/*13*/{ hue_selector_proc,       104, 64,  30,  10,  CTX, CFG, 0,   D_EXIT, 0,          0,  NULL,            NULL,     NULL },
/*14*/{ d_text_proc,             4,   76,  104, 8,   CTX, CFG, 0,   0,      0,          0,  "Default room settings:",  NULL,     NULL },
/*15*/{ zrbv_list_proc,          4,   86,  154, 52,  CTX, CFG, 0,   0,      0,          0,  zrbv_lister,     NULL,     NULL },
/*16*/{ zstype_list_proc,        162, 86,  154, 52,  CTX, CFG, 0,   0,      0,          0,  zstype_lister,   NULL,     NULL },
/*17*/{ d_button_proc,           236, 142, 80,  15,  CTX, CFG, 0,   D_EXIT, 0,          0,  "Finished",      NULL,     NULL },
standarnd_dialog_chunks
};

DIALOG door_key_picker_dlg[]=
{
     /* proc,                    x,   y,   w,   h,   fg,  bg,  key, flags,  d1,         d2, dp,              dp2,               dp3 */
/*00*/{ d_shadow_box_proc,       0,   0,   320, 125, CTX, CFG, 0,   0,      0,          0,  NULL,            NULL,              NULL },
/*01*/{ d_ctext_proc,            160, 2,   0,   0,   CTX, CFG, 0,   0,      0,          0,  "Pick a key",    NULL,              NULL },
/*02*/{ d_door_key_picker_proc,  5,   12,  310, 12,  CTX, CFG, 0,   D_EXIT, 0,          0,  blankstr,        key_lister,        NULL },
/*03*/{ d_check_proc,            5,   30,  60,  8,   CTX, CFG, 0,   0,      1,          0,  "No key",        NULL,              NULL },
/*04*/{ d_button_proc,           120, 106, 80,  15,  CTX, CFG, 0,   D_EXIT, 0,          0,  "Finished",      NULL,              NULL },
standarnd_dialog_chunks
};

int d_stat_line_proc( int msg, DIALOG *d, int c )
{
    static int o_cur_room = -50;

    if( msg == MSG_DRAW || o_cur_room != cur_room){
      o_cur_room = cur_room;
      c = 0;
//      rectfill( screen, d->x, d->y, d->x+d->w, d->y+d->h, d->bg );
      text_mode( d->bg );
      if( cur_room > -1 && cur_zone > -1 )
        textprintf( screen, font, d->x, d->y, d->fg, "vnum: %d   ", world.zone[cur_zone].room[cur_room].vnum );
      }

    return D_O_K;
}

void quick_do_dir( int setto )
{
    if( cur_room < 0 )
      return;
    if( cur_dir == setto ){
      cur_dir = -1;
      edmode = EM_NORM;
      }
    else{
      cur_dir = setto;
      if( !find_door_dir_room( &world.zone[cur_zone].room[cur_room], cur_dir ) ){
        odir = oppdir( cur_dir );
        edmode = EM_DPADD;
        }
      else{
        edmode = EM_DPICK;
        }
      }

    udisp( 4 );
    udisp( 3 );
    udisp( 7 );
}

int quick_do_north()
{
    quick_do_dir( 0 );
    return D_O_K;
}

int quick_do_east()
{
    quick_do_dir( 1 );
    return D_O_K;
}

int quick_do_south()
{
    quick_do_dir( 2 );
    return D_O_K;
}

int quick_do_west()
{
    quick_do_dir( 3 );
    return D_O_K;
}

int quick_do_up()
{
    quick_do_dir( 4 );
    return D_O_K;
}

int quick_do_down()
{
    quick_do_dir( 5 );
    return D_O_K;
}

int quick_do_none()
{
    cur_dir = -1;
    edmode = EM_NORM;

    udisp( 4 );
    udisp( 3 );
    udisp( 7 );

    return D_O_K;
}

int tagview_check_proc( int msg, DIALOG *d, int c )
{
    int ret = d_check_proc( msg, d, c );

    if( msg == MSG_START ){
      if( (mapopt&DRAW_TAGS) )
        d->flags = D_SELECTED;
      else
        d->flags = 0;
      }
    if( msg == MSG_CLICK ){
      if( (d->flags&D_SELECTED) && !(mapopt&DRAW_TAGS) ){
        mapopt = mapopt|DRAW_TAGS;
        udisp( 5 );
        }
      else if( !(d->flags&D_SELECTED) && (mapopt&DRAW_TAGS) ){
        mapopt = mapopt&(~(DRAW_TAGS));
        udisp( 5 );
        }
      }

    return ret;
}

int coasterview_check_proc( int msg, DIALOG *d, int c )
{
    int ret = d_check_proc( msg, d, c );

    if( msg == MSG_START ){
      if( (mapopt&DRAW_COASTERS) )
        d->flags = D_SELECTED;
      else
        d->flags = 0;
      }
    if( msg == MSG_CLICK ){
      if( (d->flags&D_SELECTED) && !(mapopt&DRAW_COASTERS) ){
        mapopt = mapopt|DRAW_COASTERS;
        udisp( 5 );
        }
      else if( !(d->flags&D_SELECTED) && (mapopt&DRAW_COASTERS) ){
        mapopt = mapopt&(~(DRAW_COASTERS));
        udisp( 5 );
        }
      }

    return ret;
}

int transview_check_proc( int msg, DIALOG *d, int c )
{
    int ret = d_check_proc( msg, d, c );

    if( msg == MSG_START ){
      if( (mapopt&DRAW_TRANS) )
        d->flags = D_SELECTED;
      else
        d->flags = 0;
      }
    if( msg == MSG_CLICK ){
      if( (d->flags&D_SELECTED) && !(mapopt&DRAW_TRANS) ){
        mapopt = mapopt|DRAW_TRANS;
        udisp( 5 );
        }
      else if( !(d->flags&D_SELECTED) && (mapopt&DRAW_TRANS) ){
        mapopt = mapopt&(~(DRAW_TRANS));
        udisp( 5 );
        }
      }

    return ret;
}

char *room_cont_lister( int index, int *list_size )
{
    static char tmp[100];
    char *str, *str2=NULL;

    if( index < 0 ){
      if( cur_room < 0 )
        *list_size = 0;
      else
        *list_size = world.zone[cur_zone].room[cur_room].num_cont;
      return NULL;
      }

    if( world.zone[cur_zone].room[cur_room].content[index].ifflag )
      tmp[0] = '?';
    else
      tmp[0] = ' ';

    if( world.zone[cur_zone].room[cur_room].content[index].type == 1 ){
      str = find_mobile_vnum_zone( &world.zone[cur_zone], world.zone[cur_zone].room[cur_room].content[index].vnum )->short_desc;
      }
    else{
      str = find_object_vnum_zone( &world.zone[cur_zone], world.zone[cur_zone].room[cur_room].content[index].vnum )->short_desc;
      }

    if( world.zone[cur_zone].room[cur_room].content[index].type == 4 ){
      str2 = find_object_vnum_zone( &world.zone[cur_zone], world.zone[cur_zone].room[cur_room].content[index].extra )->short_desc;
      }
    else if( world.zone[cur_zone].room[cur_room].content[index].type == 3 ){
      str2 = zone_command_wear_desc[world.zone[cur_zone].room[cur_room].content[index].extra];
      }

    if( str )
      sprintf( &tmp[1], zone_command_desc[world.zone[cur_zone].room[cur_room].content[index].type], str, world.zone[cur_zone].room[cur_room].content[index].max, str2 );
    else
      sprintf( &tmp[1], zone_command_desc[world.zone[cur_zone].room[cur_room].content[index].type], "*unknown*", world.zone[cur_zone].room[cur_room].content[index].max, str2 );

    return tmp;
}

int room_cont_list_proc( int msg, DIALOG *d, int c )
{
    int ret, mmb;

    mmb = mouse_b;

    if( cur_room > -1 ){
      if( (D_DISABLED&d->flags) ){
        d->flags = d->flags&(~(D_DISABLED));
        d->proc( MSG_DRAW, d, 0 );
        }

      if( msg == MSG_DCLICK ){
        d->proc( MSG_DRAW, d, 0 );
        }

      if( msg == MSG_CHAR ){
        if( (key_shifts & KB_CTRL_FLAG) ){
          if( c>>8 == KEY_UP ){ /* Move an item up one (swap) */
            if( d->d1 > 0 ){
              ret = world.zone[cur_zone].room[cur_room].content[d->d1].type;
              world.zone[cur_zone].room[cur_room].content[d->d1].type = world.zone[cur_zone].room[cur_room].content[d->d1-1].type;
              world.zone[cur_zone].room[cur_room].content[d->d1-1].type = ret;

              ret = world.zone[cur_zone].room[cur_room].content[d->d1].vnum;
              world.zone[cur_zone].room[cur_room].content[d->d1].vnum = world.zone[cur_zone].room[cur_room].content[d->d1-1].vnum;
              world.zone[cur_zone].room[cur_room].content[d->d1-1].vnum = ret;

              ret = world.zone[cur_zone].room[cur_room].content[d->d1].ifflag;
              world.zone[cur_zone].room[cur_room].content[d->d1].ifflag = world.zone[cur_zone].room[cur_room].content[d->d1-1].ifflag;
              world.zone[cur_zone].room[cur_room].content[d->d1-1].ifflag = ret;

              ret = world.zone[cur_zone].room[cur_room].content[d->d1].max;
              world.zone[cur_zone].room[cur_room].content[d->d1].max = world.zone[cur_zone].room[cur_room].content[d->d1-1].max;
              world.zone[cur_zone].room[cur_room].content[d->d1-1].max = ret;

              ret = world.zone[cur_zone].room[cur_room].content[d->d1].extra;
              world.zone[cur_zone].room[cur_room].content[d->d1].extra = world.zone[cur_zone].room[cur_room].content[d->d1-1].extra;
              world.zone[cur_zone].room[cur_room].content[d->d1-1].extra = ret;
              d->d1--;
              d->proc( MSG_DRAW, d, 0 );
              }
            return D_USED_CHAR;
            }
          else if( c>>8 == KEY_DOWN ){ /* Move an item down one (swap) */
            if( d->d1 < world.zone[cur_zone].room[cur_room].num_cont-1 ){
              ret = world.zone[cur_zone].room[cur_room].content[d->d1].type;
              world.zone[cur_zone].room[cur_room].content[d->d1].type = world.zone[cur_zone].room[cur_room].content[d->d1+1].type;
              world.zone[cur_zone].room[cur_room].content[d->d1+1].type = ret;

              ret = world.zone[cur_zone].room[cur_room].content[d->d1].vnum;
              world.zone[cur_zone].room[cur_room].content[d->d1].vnum = world.zone[cur_zone].room[cur_room].content[d->d1+1].vnum;
              world.zone[cur_zone].room[cur_room].content[d->d1+1].vnum = ret;

              ret = world.zone[cur_zone].room[cur_room].content[d->d1].ifflag;
              world.zone[cur_zone].room[cur_room].content[d->d1].ifflag = world.zone[cur_zone].room[cur_room].content[d->d1+1].ifflag;
              world.zone[cur_zone].room[cur_room].content[d->d1+1].ifflag = ret;

              ret = world.zone[cur_zone].room[cur_room].content[d->d1].max;
              world.zone[cur_zone].room[cur_room].content[d->d1].max = world.zone[cur_zone].room[cur_room].content[d->d1+1].max;
              world.zone[cur_zone].room[cur_room].content[d->d1+1].max = ret;

              ret = world.zone[cur_zone].room[cur_room].content[d->d1].extra;
              world.zone[cur_zone].room[cur_room].content[d->d1].extra = world.zone[cur_zone].room[cur_room].content[d->d1+1].extra;
              world.zone[cur_zone].room[cur_room].content[d->d1+1].extra = ret;
              d->d1++;
              d->proc( MSG_DRAW, d, 0 );
              }
            return D_USED_CHAR;
            }
          }
        }
      ret = d_list_proc( msg, d, c );

      if( msg == MSG_DCLICK ){
        if( d->d1 > 0 &&
            d->d1 < world.zone[cur_zone].room[cur_room].num_cont &&
            world.zone[cur_zone].room[cur_room].num_cont > 0 ){
          do_cont_prop_dlg( d->d1 );
          return D_REDRAW;
          }
        }

      if( msg == MSG_CLICK ){
        if( mmb & 2 ){
          if( world.zone[cur_zone].room[cur_room].num_cont > 0 ){
            room_cont_menu[1].flags &= ~D_DISABLED;
            room_cont_menu[2].flags &= ~D_DISABLED;
            }
          else{
            room_cont_menu[1].flags |= D_DISABLED;
            room_cont_menu[2].flags |= D_DISABLED;
            }
          switch( do_menu( room_cont_menu, mouse_x, mouse_y ) ){
            case 0:  /* Add new */
                 c = add_room_content( &world.zone[cur_zone].room[cur_room] );
                 world.zone[cur_zone].room[cur_room].content[c].type = 0;
                 world.zone[cur_zone].room[cur_room].content[c].vnum = 0;
                 world.zone[cur_zone].room[cur_room].content[c].extra = 0;
                 do_cont_prop_dlg( c );
                 return D_REDRAW;
                 break;

            case 1:  /* Edit instance */
                 do_cont_prop_dlg( d->d1 );
                 return D_REDRAW;
                 break;

            case 2:  /* Remove */
                 del_room_content( &world.zone[cur_zone].room[cur_room], d->d1 );
                 d->proc( MSG_DRAW, d, 0 );
                 break;
            }
          }
        }
      else if( msg == MSG_DCLICK && world.zone[cur_zone].room[cur_room].num_cont > 0 ){
        do_cont_prop_dlg( d->d1 );
        return D_REDRAW;
        }
      }
    else{
      if( !(D_DISABLED&d->flags) ){
        d->flags = d->flags|D_DISABLED;
        d->proc( MSG_DRAW, d, 0 );
        }

      ret = d_list_proc( msg, d, c );
      }

    return ret;
}

void udisp( int id )
{
    main_dlg[id].proc( MSG_USER, &main_dlg[id], 0 );
    main_dlg[id].proc( MSG_DRAW, &main_dlg[id], 0 );
}

int init_main_dialog()
{
    set_colors( main_dlg );
    set_colors( tag_prop_dlg );
    set_colors( rexd_prop_dlg );
    set_colors( door_keyword_dlg );
    set_colors( zone_prop_dlg );
    set_colors( door_key_picker_dlg );
    centre_dialog( zone_prop_dlg );
    centre_dialog( tag_prop_dlg );
    centre_dialog( rexd_prop_dlg );
    centre_dialog( door_keyword_dlg );
    centre_dialog( door_key_picker_dlg );

    return do_dialog( main_dlg, 0 );
}

int wrld_save_as()
{
    char path[512]="";

    if( file_select( "Select a file to save to or create", path, "ymw" ) ){
      if( !save_world( path, &world ) )
        alert("ERROR", "There was an error saving to the specified file", NULL, "Damn!", NULL, NULL, NULL );
      strcpy( filename, path );
      }

    return D_REDRAW;
}

int wrld_save()
{
    if( strlen(filename) > 0 ){
      if( !save_world( filename, &world ) )
        alert("ERROR", "There was an error saving to the specified file", NULL, "Damn!", NULL, NULL, NULL );
      }
    else{
      return wrld_save_as();
      }

    return D_REDRAW;
}

int wrld_load()
{
    char path[512]="";

    if( file_select( "Select a map to load", path, "ymw" ) ){
      destroy_world( &world );
      new_world( &world );
      if( !load_world( path, &world ) )
        alert("ERROR", "There was an error loading the specified file", NULL, "Damn!", NULL, NULL, NULL );
      cur_room = -1;
      strcpy( filename, path );
      }

    return D_REDRAW;
}

int wrld_export()
{
    char path[512];
    int j, k, haszero=FALSE;

    for( j = 0; j < world.num_zones; j++ ){
       if( world.zone[j].vnum == 0 ){
         for( k = 0; k < world.zone[j].num_rooms; k++ ){
            if( world.zone[j].room[k].vnum == 0 ){
              haszero = TRUE;
              break;
              }
            }
         }
       }

    if( !haszero ){
      if( alert( "You don't have a zero room, this is necesary to run the windows",
                 "version of the YFMud server.  The zero room needs to be in zone zero and",
                 "needs a vnum of zero.  You can export if you want, but it won't work",
                 "I'll check it out", "Go ahead and export",
                 NULL, NULL ) == 1 ){
        return D_REDRAW;
        }
      }

    memset( path, 0, 512 );
    getwd( path );

    if(!__file_exists("server\\mud.exe")){
      if( alert( "You don't seem to actually have the server loaded.",
                 "You can download it from http://www.mud.yf-soft.com",
                 "Alternatively, you can export to the dir ``world''",
                 "Nevermind...", "Do it anyway...", 
                 NULL, NULL ) == 2 ){
        strcat( path, "\\world" );
        }
      else{
        return D_REDRAW;
        }
      }
    else{
      strcat( path, "\\server\\lib\\world" );
      }

    mkdir( path, S_IWUSR );

    export_world( path, &world );
    set_color_depth( 16 );
    set_gfx_mode( GFX_AUTODETECT, 640, 480, 0, 0 );
    show_mouse( screen );
    set_trans_blender( 128, 128, 128, 128 );
    set_colors( NULL );

    return D_REDRAW;
}

int wrld_blank()
{
    int ret;

    destroy_world( &world );
    new_world( &world );
    ret = add_zone( &world );
    if( strcmp( username, "Not Registered" ) )
      strcpy( world.zone[ret].author, username );
    do_zone_prop_dlg( FALSE, ret );
    cur_room = -1;
    cur_zone = 0;
    edmode = EM_NORM;
    cur_dir = -1;
    odir = -1;

    return D_REDRAW;
}

int temp_text_deal()
{
    set_gfx_mode( GFX_TEXT, 0, 0, 0, 0 );
    clear_keybuf();
    printf("Press any key to return to YFMudEd.\n\n");
    readkey();
    set_color_depth( 16 );
    set_gfx_mode( GFX_AUTODETECT, 640, 480, 0, 0 );
    show_mouse( screen );

    gui_fg_color = makecol( 20,  15,  20  );
    gui_bg_color = makecol( 175, 190, 175 );

    return D_REDRAW;
}

int do_exit()
{
    return D_EXIT;
}

void _handle_scrollable_scroll(DIALOG *d, int listsize, int *index, int *offset);
void _handle_scrollable_scroll_click(DIALOG *d, int listsize, int *offset);
void _draw_scrollable_frame(DIALOG *d, int listsize, int offset, int height, int fg_color, int bg);

int d_mledit_proc(int msg, DIALOG *d, int c)
{
    int j, x, y, ret=D_O_K, rset=FALSE;

#define str ((cur_room<0)?((char *)d->dp):((cur_dir>-1 && find_door_dir_room(&world.zone[cur_zone].room[cur_room], cur_dir)!=NULL)?(find_door_dir_room(&world.zone[cur_zone].room[cur_room],cur_dir)->desc):(world.zone[cur_zone].room[cur_room].desc)))
#define spos ((int *)d->dp2)[0]
#define ssiz ((int *)d->dp2)[1]
#define osel ((int *)d->dp2)[2]
#define msiz ((d->h-4)/8)
#define mwid ((d->w-17)/8)

    if( msg == MSG_START ){
      d->d2 = 0;
      d->dp = malloc( 26 );
      strcpy( d->dp, "No room or door selected." );
      d->dp2 = malloc( sizeof(int)*3 );
      spos = 0;
      ssiz = 0;
      osel = cur_room;
      return D_O_K;
      }

    if( ssiz < msiz ) spos = 0;
    if( cur_room == -1 )
      d->flags |= D_DISABLED;
    else{
      d->flags = 0;
      if( osel != cur_room ){
        osel = cur_room;
        spos = 0;
        ssiz = 0;
        d->d2 = 0;
        }
      else if( (size_t)(d->d2) > strlen(str) ){
        d->d2 = strlen(str);
        }
      }
    switch( msg ){
      case MSG_END:
           break;

      case MSG_WANTFOCUS:
      case MSG_LOSTFOCUS:
      case MSG_KEY:
	 return D_WANTFOCUS;

      case MSG_CLICK:
         if ((!(ssiz > msiz)) || (gui_mouse_x() < d->x+d->w-13)) {
	    /* clicked on the text area */
	    ret = D_O_K;
	 }
	 else {
	    /* clicked on the scroll area */
	    _handle_scrollable_scroll_click(d, ssiz, &spos);
	 }
           break;

      case MSG_CHAR:
           if( (d->flags & D_DISABLED) )
             return D_O_K;
           if ((c >> 8) == KEY_LEFT) {
             if( d->d2 > 0 ){
               d->d2--;
               }
             ret = D_USED_CHAR;
             }
           else if ((c >> 8) == KEY_RIGHT) {
             if( (size_t)(1+d->d2) <= strlen(str) ){
               d->d2++;
               }
             ret = D_USED_CHAR;
             }
           else if ((c >> 8) == KEY_UP){
             j = strlen(str);
             for( y = 0; y > -mwid; y-- ){
                if( str[y+d->d2] == 13 ) break;
                }
             if( y == -mwid ) y = -1;
             for( x = y-1; x >= -mwid; x-- ){
                if( str[x+d->d2] == 13 ) break;
                }

             d->d2 += x-y;
             if( d->d2 < 0 ){
               d->d2 = 0;
               }
             ret = D_USED_CHAR;
             }
           else if ((c >> 8) == KEY_DOWN){
             j = strlen(str);
             for( x = 1; x < mwid && x < j; x++ ){
                if( str[x+d->d2] == 13 ) break;
                }
             if( x == mwid ) x = -1;
             for( y = 0; y >= -mwid; y-- ){
                if( str[y+d->d2] == 13 ) break;
                }

             d->d2 += x-y;
             if( d->d2 > j ){
               d->d2 = j;
               }
             ret = D_USED_CHAR;
             }
           else if ((c >> 8) == KEY_DEL){
             if( (size_t)(1+d->d2) <= strlen(str) ){
               strcpy( &str[d->d2], &str[1+d->d2]  );
//               str = realloc( str, strlen(str)+1 );
               ret = D_USED_CHAR;
               }
             else{
               ret = D_O_K;
               }
             }
           else if ((c >> 8) == KEY_BACKSPACE){
             if( d->d2 > 0 ){
               strcpy( &str[d->d2-1], &str[d->d2]  );
//               str = realloc( str, strlen(str)+1 );
               d->d2--;
               ret = D_USED_CHAR;
               }
             else{
               ret = D_O_K;
               }
             }
           else if ((c >> 8) == KEY_HOME){
             d->d2 = 0;
             ret = D_USED_CHAR;
             }
           else if ((c >> 8) == KEY_END){
             d->d2 = strlen(str);
             ret = D_USED_CHAR;
             }
           else if (((c & 0xFF ) >= 32 && (c & 0xFF ) <= 126) || (c >> 8) == KEY_ENTER ){
//             str = realloc( str, strlen(str)+2 );
             x = strlen(str)+1;
             if( (size_t)(d->d2) == strlen(str) ) rset = TRUE;
             for( j = x; j > d->d2; j-- ){
                str[j] = str[j-1];
                }
             str[d->d2] = c & 0xFF;
             d->d2++;
             ret = D_USED_CHAR;
             }
           break;

      case MSG_DRAW:
           ret = D_REDRAW;
           break;
      }

    if( ret == D_USED_CHAR || ret == D_REDRAW ){
      text_mode( d->bg );
      rectfill( screen, d->x+2, d->y+2, d->x+d->w-((ssiz < msiz) ? 2 : 15), d->y+d->h-2, d->bg );

      x = 0;
      y = 0;
      if( strlen(str) == 0 && !(d->flags & D_DISABLED) ){
        vline( screen, 3+d->x, 3+d->y, 11+d->y, d->fg );
        }
      for( j = 0; (size_t)(j) < strlen(str); j++ ){
         if( str[j] == 13 ){
           x = 0;
           y++;
           }
         else{
           if( y < spos+msiz && y >= spos )
             textprintf( screen, font, (x*8)+4+d->x, (y*8)+4+d->y-spos*8, (d->flags & D_DISABLED) ? gui_mg_color : d->fg, "%c", str[j] );
           x++;
           if( x*8+8 >= d->w-17 ){
             x = 0;
             y++;
             }
           }
         if( d->d2 == 0 && spos == 0 && !(d->flags & D_DISABLED) ){
           vline( screen, 3+d->x, 3+d->y-spos*8, 11+d->y-spos*8, gui_fg_color );
           }
         if( d->d2-1 == j && y < spos+msiz && y >= spos && !(d->flags & D_DISABLED) ){
           vline( screen, (x)*8+3+d->x, (y)*8+3+d->y-spos*8, (y)*8+11+d->y-spos*8, d->fg );
           }
         }
      ssiz = y+1;
      if( rset ) spos = (ssiz < msiz) ? 0 : ssiz-msiz;
      _draw_scrollable_frame(d, ssiz, spos, msiz, d->fg, d->bg);
      if( ret == D_REDRAW ) ret = D_O_K;
      }

#undef str
#undef spos
#undef ssiz
#undef osel
#undef msiz
#undef mwid
    return ret;
}

int d_myedit_proc( int msg, DIALOG *d, int c )
{
    char buf[]="No room selected.";

    if( msg == MSG_START ){
      d->dp2 = malloc( sizeof(int) );
      ((int *)d->dp2)[0] = cur_room;
      }

    if( cur_room == -1 ){
      d->flags |= D_DISABLED;
      d->dp = buf;
      }
    else{
      if( (d->flags & D_DISABLED) )
        d->flags ^= D_DISABLED;
      d->dp = world.zone[cur_zone].room[cur_room].title;
      }

    if( cur_room != ((int *)d->dp2)[0] ){
      ((int *)d->dp2)[0] = cur_room;
      if( msg != MSG_DRAW )
        d_edit_proc( MSG_DRAW, d, 0 );
      }

    return d_edit_proc( msg, d, c );
}

char *rbv_lister(int index, int *list_size)
{
    static char tmp[42]="";

    if( index < 0 ){
      *list_size = 11;
      return rbv_list[0];
      }

    if( cur_room > -1 ){
      tmp[41] = '\0';
      strncpy( &tmp[1], rbv_list[index], 40 );
      if( ((1<<index)&world.zone[cur_zone].room[cur_room].rbv) ){
        tmp[0] = '';//'>';
        }
      else{
        tmp[0] = ' ';
        }
      return tmp;
      }

    return rbv_list[index];
}

int rbv_list_proc( int msg, DIALOG *d, int c )
{
    int ret = d_list_proc( msg, d, c );
//    int j;

    if( cur_room > -1 ){
      if( (D_DISABLED&d->flags) ){
        d->flags = d->flags&(~(D_DISABLED));
        udisp( 8 );
        }

      if( msg == MSG_USER ){
        }
  
      if( msg == MSG_DCLICK ){
        if( ((1<<d->d1)&world.zone[cur_zone].room[cur_room].rbv) ){
          world.zone[cur_zone].room[cur_room].rbv = world.zone[cur_zone].room[cur_room].rbv&(~(1<<d->d1));
          }
        else{
          world.zone[cur_zone].room[cur_room].rbv = world.zone[cur_zone].room[cur_room].rbv|(1<<d->d1);
          }
        udisp( 8 );
        }
      }
    else{
      if( !(D_DISABLED&d->flags) ){
        d->flags = d->flags|D_DISABLED;
        udisp( 8 );
        }
      }

    return ret;
}

int oppdir( int dir )
{
    switch( dir ){
      case D_NORTH:
           return D_SOUTH;

      case D_EAST:
           return D_WEST;

      case D_SOUTH:
           return D_NORTH;

      case D_WEST:
           return D_EAST;

      case D_UP:
           return D_DOWN;

      case D_DOWN:
           return D_UP;
      }

    return -1;
}

int del_this_door()
{
    del_door( &world.zone[cur_zone].room[cur_room], ifind_door_dir_room( &world.zone[cur_zone].room[cur_room], cur_dir ) );

    return D_REDRAW;
}

void do_door_keyword_dlg()
{
    door_keyword_dlg[2].dp = world.zone[cur_zone].room[cur_room].door[ifind_door_dir_room( &world.zone[cur_zone].room[cur_room], cur_dir )].keywords;
    do_dialog( door_keyword_dlg, 2 );
    door_keyword_dlg[2].dp = NULL;
}

int d_door_setter( int msg, DIALOG *d, int c )
{
    int j;
    static int ocur_room;
    static ROOM lrm[6];
    DOOR *door, *odoor;

    switch( msg ){
      case MSG_START:
           ocur_room = cur_room;
           cur_dir = -1;
           lrm[0].x = d->x+d->w/2;
           lrm[0].y = d->y+d->h/2-GS;

           lrm[1].x = d->x+d->w/2+GS;
           lrm[1].y = d->y+d->h/2;

           lrm[2].x = d->x+d->w/2;
           lrm[2].y = d->y+d->h/2+GS;

           lrm[3].x = d->x+d->w/2-GS;
           lrm[3].y = d->y+d->h/2;

           lrm[4].x = d->x+d->w/2-GS;
           lrm[4].y = d->y+d->h/2-GS;

           lrm[5].x = d->x+d->w/2+GS;
           lrm[5].y = d->y+d->h/2+GS;
           break;

      case MSG_CLICK:
           edmode = EM_NORM;
           if( cur_room > -1 ){
             for( j = 0; j < ND; j++ ){
                if( mouse_x >= lrm[j].x-RR && mouse_x <= lrm[j].x+RR &&
                    mouse_y >= lrm[j].y-RR && mouse_y <= lrm[j].y+RR ){
                  cur_dir = j;
                  door = find_door_dir_room( &world.zone[cur_zone].room[cur_room], j );
                  if( !door ){
                    odir = oppdir(j);
                    edmode = EM_DPADD;
                    }
                  else{
                    if( mouse_b & 1 ){
                      edmode = EM_DPICK;
                      }
                    if( (mouse_b & 2) ){
                      edmode = EM_DPICK;
                      udisp( 4 );

                      menu_dtype[0].flags &= ~D_SELECTED;
                      menu_dtype[1].flags &= ~D_SELECTED;
                      menu_dtype[2].flags &= ~D_SELECTED;
                      menu_dtype[door->typea].flags |= D_SELECTED;

                      menu_dtype[4].flags &= ~D_SELECTED;
                      menu_dtype[5].flags &= ~D_SELECTED;
                      menu_dtype[6].flags &= ~D_SELECTED;
                      if( !(door->typeb        & D_CANT_LEAVE) &&
                          !(door->other->typeb & D_CANT_LEAVE) ){
                        menu_dtype[4].flags |= D_SELECTED;
                        }
                      else if( door->other->typeb & D_CANT_LEAVE ){
                        menu_dtype[5].flags |= D_SELECTED;
                        }
                      else if( door->typeb & D_CANT_LEAVE ){
                        menu_dtype[6].flags |= D_SELECTED;
                        }

                      menu_dstate[0].flags &= ~D_SELECTED;
                      menu_dstate[1].flags &= ~D_SELECTED;
                      menu_dstate[2].flags &= ~D_SELECTED;
                      menu_dstate[door->state].flags |= D_SELECTED;

                      menu_door[0].dp = door;

                      switch( do_menu( menu_door, mouse_x, mouse_y ) ){
                        case 0:
                             for( j = 0; j < ND; j++ ){
                                odoor = find_door_dir_room( door->other->parent, (j+door->other->dir)%ND );
                                if( odoor == NULL ){
                                  door->other->dir = (j+door->other->dir)%ND;
                                  break;
                                  }
                                }
                             edmode = EM_NORM;
                             cur_dir = odir = -1;
                             break;

                        case 1:
                             edmode = EM_DPICK;
                             udisp( 4 );
                             break;

                        case 4:
                             edmode = EM_NORM;
                             cur_dir = odir = -1;
                             return D_REDRAW;
                             break;

                        case 6:
                             do_door_keyword_dlg();
                             break;
                        }
                      udisp( 4 );
                      udisp( 5 );
                      udisp( 10 );
                      }
                    else{
                      odir = oppdir(j);
                      }
                    }
                  break;
                  }
                }
             if( j == ND )
               cur_dir = odir = -1;
             }
           udisp( 4 );
           break;

      case MSG_DRAW:
           scare_mouse();
           d_box_proc( MSG_DRAW, d, c );
           if( cur_room > -1 ){
             room3d( screen, d->x+d->w/2-RR,    d->y+d->h/2-RR,    RR*2+1, RR*2+1, makecol( 255, 255, 255 ), makecol( 115, 115, 115 ), makecol( 200, 85, 80 ) );
             for( j = 0; j < ND; j++ ){
                if( j == cur_dir ){
                  if( edmode == EM_DPICK ){
                    room3d( screen, lrm[j].x-RR, lrm[j].y-RR, RR*2+1, RR*2+1, makecol( 255, 255, 255 ), makecol( 115, 115, 115 ), makecol( 85, 200, 80 ) );
                    }
                  else{
                    room3d( screen, lrm[j].x-RR, lrm[j].y-RR, RR*2+1, RR*2+1, makecol( 255, 255, 255 ), makecol( 115, 115, 115 ), makecol( 200, 85, 80 ) );
                    }
                  udisp( 3 );
                  udisp( 7 );
                  }
                else{
                  if( j == 4 )
                    rectfill( screen, lrm[j].x-RR, lrm[j].y-RR, lrm[j].x-RR+RR*2+1, lrm[j].y-RR+RR*2+1, makecol( 50, 150, 196 ) );
                  else if( j == 5 )
                    rect( screen, lrm[j].x-RR, lrm[j].y-RR, lrm[j].x-RR+RR*2+1, lrm[j].y-RR+RR*2+1, makecol( 230, 230, 230 ) );
                  else
                    room3d( screen, lrm[j].x-RR, lrm[j].y-RR, RR*2+1, RR*2+1, makecol( 255, 255, 255 ), makecol( 115, 115, 115 ), makecol( 200, 225, 200 ) );
                  }
                }
             for( j = 0; j < world.zone[cur_zone].room[cur_room].num_doors; j++ ){
                draw_door( screen,
                           d->x+d->w/2,
                           d->y+d->h/2,
                           world.zone[cur_zone].room[cur_room].door[j].dir,
                           world.zone[cur_zone].room[cur_room].door[j].typea,
                           world.zone[cur_zone].room[cur_room].door[j].typeb,
                           world.zone[cur_zone].room[cur_room].door[j].state,
                           lrm[world.zone[cur_zone].room[cur_room].door[j].dir].x,
                           lrm[world.zone[cur_zone].room[cur_room].door[j].dir].y,
                           world.zone[cur_zone].room[cur_room].door[j].other->dir,
                           world.zone[cur_zone].room[cur_room].door[j].other->typea,
                           world.zone[cur_zone].room[cur_room].door[j].other->typeb,
                           world.zone[cur_zone].room[cur_room].door[j].other->state,
                           0,
                           TRUE
                           );
                }
             }
           unscare_mouse();

      case MSG_IDLE:
           if( cur_room == ocur_room )
             break;
           ocur_room = cur_room;
           break;
      }

    return D_O_K;
}

int del_this_room()
{
    MSEL_ITEM *cur;

    if( cur_room > -1 ){
      del_room( &world.zone[cur_zone], cur_room );
      cur_room = -1;
      }
    else if( msel_list.num_sel > 0 ){
      if( alert( "Danger!", "Are you sure you want to delete multiple rooms, here?", NULL, "Yes, I am", "Um, not really", NULL, NULL ) == 2 )
        return D_REDRAW;
      cur = msel_list.base;
      do{
        cur->x = world.zone[cur->hi_ind].vnum;
        cur->y = world.zone[cur->hi_ind].room[cur->lo_ind].vnum;
        cur = cur->next;
        } while( cur != msel_list.base );
      cur = msel_list.base;
      do{
        del_room( &world.zone[ifind_zone_vnum_world( &world, cur->x )], ifind_room_vnum_zone( &world.zone[ifind_zone_vnum_world( &world, cur->x )], cur->y ) );
        cur = cur->next;
        } while( cur != msel_list.base );
      del_msel_list( &msel_list );
      }

    return D_REDRAW;
}

void tag_prop( int index )
{
    tag_prop_dlg[2].dp = world.zone[cur_zone].tag[index].str;
    do_dialog( tag_prop_dlg, 2 );
    tag_prop_dlg[2].dp = NULL;
}

BITMAP *genbmp;

int d_ed_box( int msg, DIALOG *d, int c )
{
    int ret = D_O_K, selmade=0;
    int j, k=0, l, x, y, myodir, myoodir, selbox[4];
    MSEL_ITEM *cur_msel=NULL;
    BITMAP *bf;
    DOOR *door, *odoor;

    switch( msg ){
      case MSG_START:
           d->d1=0;
           d->d2=0;
           genbmp = create_bitmap( SCREEN_W, SCREEN_H );
           break;

      case MSG_END:
           destroy_bitmap( genbmp );
           break;

      case MSG_WANTFOCUS:
           return D_WANTFOCUS;

      case MSG_DRAW:
           scare_mouse();
           bf = create_sub_bitmap( genbmp, d->x+2, d->y+2, d->w-4, d->h-4 );
           clear_to_color( bf, d->bg );
           if( msel_list.num_sel < 1 )
             draw_map( &world, bf, d->d1, d->d2, cur_layer, DMODE_SINGLE, (void *)(cur_zone), (void *)(cur_room), mapopt );
           else
             draw_map( &world, bf, d->d1, d->d2, cur_layer, DMODE_MSEL, NULL, &msel_list, mapopt );
           blit( bf, screen, 0, 0, d->x+2, d->y+2, bf->w, bf->h );
           if( (d->flags&D_GOTFOCUS) ){
             rect( screen, d->x, d->y, d->x+d->w, d->y+d->h, d->fg );
             dotted_rect( screen, d->x+1, d->y+1, d->x+d->w-1, d->y+d->h-1, d->fg, d->bg );
             }
           else{
             rect( screen, d->x, d->y, d->x+d->w, d->y+d->h, d->fg );
             rect( screen, d->x+1, d->y+1, d->x+d->w-1, d->y+d->h-1, d->bg );
             }
           unscare_mouse();
           break;

      case MSG_CHAR:
           if( c>>8 == KEY_INSERT ){
             x = mouse_x-d->x-1 - d->w/2 - d->d1;
             y = mouse_y-d->y-1 - d->h/2 - d->d2;

             if( x < 0 )
               x = (int)(x/(float)(GS)-.5);
             else
               x = (int)(x/(float)(GS)+.5);

             if( y < 0 )
               y = (int)(y/(float)(GS)-.5);
             else
               y = (int)(y/(float)(GS)+.5);

             add_room( &world.zone[cur_zone], x, y, cur_layer );

             udisp( 5 );
             return D_USED_CHAR;
             }
           if( c>>8 == KEY_PGUP ){
             cur_layer++;
             if( (key_shifts&KB_CTRL_FLAG) ){
               if( cur_zone > -1 && cur_room > -1 ){
                 world.zone[cur_zone].room[cur_room].z = cur_layer;
                 }
               else if( msel_list.num_sel ){
                 cur_msel = msel_list.base;
                 do{
                   world.zone[cur_msel->hi_ind].room[cur_msel->lo_ind].z++;
                   cur_msel = cur_msel->next;
                   } while( cur_msel != msel_list.base );
                 }
               }
             udisp( 5 );
             return D_USED_CHAR;
             }
           if( c>>8 == KEY_PGDN ){
             cur_layer--;
             if( (key_shifts&KB_CTRL_FLAG) ){
               if( cur_zone > -1 && cur_room > -1 ){
                 world.zone[cur_zone].room[cur_room].z = cur_layer;
                 }
               else if( msel_list.num_sel ){
                 cur_msel = msel_list.base;
                 do{
                   world.zone[cur_msel->hi_ind].room[cur_msel->lo_ind].z--;
                   cur_msel = cur_msel->next;
                   } while( cur_msel != msel_list.base );
                 }
               }
             udisp( 5 );
             return D_USED_CHAR;
             }
           break;

      case MSG_CLICK:
           x = mouse_x-d->x-1;
           y = mouse_y-d->y-1;
           x = x - d->w/2 - d->d1;
           y = y - d->h/2 - d->d2;
           if( (key_shifts&KB_SHIFT_FLAG) ){
             if( !(key_shifts&KB_CTRL_FLAG) ){
               del_msel_list( &msel_list );
               }
             selbox[0] = x;
             selbox[1] = y;
             get_mouse_mickeys( &j, &k );
             scare_mouse();
             bf = create_sub_bitmap( genbmp, d->x+2, d->y+2, d->w-4, d->h-4 );
             do{
               get_mouse_mickeys( &j, &k );
               if( mouse_x < d->x ){
                 d->d1 += 3;
                 j = 1;
                 }
               else if( mouse_x > d->x+d->w ){
                 d->d1 -= 3;
                 j = 1;
                 }
               if( mouse_y < d->y ){
                 d->d2 += 3;
                 j = 1;
                 }
               else if( mouse_y > d->y+d->h ){
                 d->d2 -= 3;
                 j = 1;
                 }
               if( j != 0 || k != 0 ){
                 selbox[2] = mouse_x-d->x-1;
                 selbox[3] = mouse_y-d->y-1;
                 selbox[2] = selbox[2] - d->w/2 - d->d1;
                 selbox[3] = selbox[3] - d->h/2 - d->d2;

                 for( j = 0; j < world.num_zones; j++ ){
                    for( k = 0; k < world.zone[j].num_rooms; k++ ){
                       if( ((selbox[0] <= world.zone[j].room[k].x*GS-RR &&
                           selbox[2] >= world.zone[j].room[k].x*GS+RR) ||
                           (selbox[0] >= world.zone[j].room[k].x*GS-RR &&
                           selbox[2] <= world.zone[j].room[k].x*GS+RR)) &&
                           ((selbox[1] <= world.zone[j].room[k].y*GS-RR &&
                           selbox[3] >= world.zone[j].room[k].y*GS+RR) ||
                           (selbox[1] >= world.zone[j].room[k].y*GS-RR &&
                           selbox[3] <= world.zone[j].room[k].y*GS+RR)) &&
                           cur_layer == world.zone[j].room[k].z ){
                         add_msel_item( &msel_list, j, k );
                         }
                       }
                    }
                 clear_to_color( bf, d->bg );
                 draw_map( &world, bf, d->d1, d->d2, cur_layer, DMODE_MSELPICK, selbox, &msel_list, mapopt );
                 blit( bf, screen, 0, 0, d->x+2, d->y+2, bf->w, bf->h );
                 rect( screen, d->x, d->y, d->x+d->w, d->y+d->h, d->fg );
                 dotted_rect( screen, d->x+1, d->y+1, d->x+d->w-1, d->y+d->h-1, d->fg, d->bg );
                 }
               } while( mouse_b && (key_shifts&KB_SHIFT_FLAG) );
             clear_to_color( bf, d->bg );
             draw_map( &world, bf, d->d1, d->d2, cur_layer, DMODE_MSEL, NULL, &msel_list, mapopt );
             blit( bf, screen, 0, 0, d->x+2, d->y+2, bf->w, bf->h );
             rect( screen, d->x, d->y, d->x+d->w, d->y+d->h, d->fg );
             dotted_rect( screen, d->x+1, d->y+1, d->x+d->w-1, d->y+d->h-1, d->fg, d->bg );

             unscare_mouse();
             break;
             }
           if( (mapopt&DRAW_TAGS) ){
             for( j = 0; j < world.num_zones; j++ ){
                for( k = 0; k < world.zone[j].num_tags; k++ ){
                   if( x >= world.zone[j].tag[k].x*GS-(world.zone[j].tag[k].w/2) &&
                       x <= world.zone[j].tag[k].x*GS+(world.zone[j].tag[k].w/2) &&
                       y >= world.zone[j].tag[k].y*GS-(world.zone[j].tag[k].h/2) &&
                       y <= world.zone[j].tag[k].y*GS+(world.zone[j].tag[k].h/2) &&
                       cur_layer == world.zone[j].tag[k].z ){
                     cur_zone = j;
                     if( mouse_b & 1 ){
                       scare_mouse();
                       get_mouse_mickeys( &x, &y );
                       while( mouse_b & 1 ){
                         get_mouse_mickeys( &x, &y );
                         if( x != 0 || y != 0 ){
                           x = mouse_x-d->x-1 - d->w/2 - d->d1;
                           y = mouse_y-d->y-1 - d->h/2 - d->d2;
       
                           if( x < 0 )
                             x = (int)(x/(float)(GS)-.5);
                           else
                             x = (int)(x/(float)(GS)+.5);
       
                           if( y < 0 )
                             y = (int)(y/(float)(GS)-.5);
                           else
                             y = (int)(y/(float)(GS)+.5);
       
                           world.zone[j].tag[k].x = x;
                           world.zone[j].tag[k].y = y;
     
                           udisp( 5 );
                           }
                         }
                       unscare_mouse();
                       }
                     else if( mouse_b & 2 ){
                       switch( do_menu( tag_on_map_menu, mouse_x, mouse_y ) ){
                         case 0:
                              del_tag( &world.zone[cur_zone], k );
                              break;
   
                         case 1:
                              tag_prop( k );
                              break;
                         }
                       }
                     }
                   }
                }
             }
           for( j = 0; j < world.num_zones; j++ ){
              for( k = 0; k < world.zone[j].num_rooms; k++ ){
                 if( x >= world.zone[j].room[k].x*GS-RR &&
                     x <= world.zone[j].room[k].x*GS+RR &&
                     y >= world.zone[j].room[k].y*GS-RR &&
                     y <= world.zone[j].room[k].y*GS+RR &&
                     cur_layer == world.zone[j].room[k].z ){

                   /* We're adding a door */
                   if( edmode == EM_DPADD ){
                     /* Make sure the source and destination rooms are different */
                     if( !(cur_room == k && cur_zone == j) ){
                       /* Check to make sure the destination is clear */
                       if( ifind_door_dir_room( &world.zone[j].room[k], odir ) != -1 ){
                         /* If not, find a spot in that room */
                         for( l = (odir+1)%ND; l != odir; l=(l+1)%ND ){
                            /* If we find a clear one...*/
                            if( ifind_door_dir_room( &world.zone[j].room[k], l ) == -1 ){
                              add_door( &world.zone[cur_zone].room[cur_room], cur_dir, &world.zone[j].room[k], l );
                              break;
                              }
                            }
                         }
                       /* If the destination is clear, just make the door */
                       else{
                         add_door( &world.zone[cur_zone].room[cur_room], cur_dir, &world.zone[j].room[k], odir );
                         }
   
                       edmode = EM_NORM;
                       cur_dir = -1;
                       odir = -1;
                       }
                     }
                   /* Re-assign a door-mode */
                   else if( edmode == EM_DPICK ){
                     if( !(cur_zone != j && cur_room != k) ){
                       /* Get the source dir */
                       door = find_door_dir_room( &world.zone[cur_zone].room[cur_room], cur_dir );
                       /* Find the destination door, same dir as the old destination came from */
                       odoor = find_door_dir_room( &world.zone[j].room[k], door->other->dir );
                       /* If it's already occupied, find another place */
                       if( odoor ){
                         /* Loop over possibilities */
                         for( l=(door->other->dir+1)%ND; l != door->other->dir; l=(l+1)%ND ){
                            odoor = find_door_dir_room( &world.zone[j].room[k], l );
                            if( !odoor ){
                              myodir = door->dir;
                              del_door( &world.zone[cur_zone].room[cur_room], ifind_door_dir_room( &world.zone[cur_zone].room[cur_room], door->dir ) );
                              add_door( &world.zone[cur_zone].room[cur_room], myodir, &world.zone[j].room[k], l );
                              rehash_world( &world );
                              udisp( 4 );  /* Update the door-picker */
                              udisp( 3 );
                              udisp( 5 );
                              udisp( 8 );
                              udisp( 9 );
                              udisp( 10 );
                              udisp( 17 );
                              udisp( 23 );
                              udisp( 24 );
                              break;
                              }
                            }
                         }
                       else{
                         myodir = door->dir;
                         myoodir = door->other->dir;
                         del_door( &world.zone[cur_zone].room[cur_room], ifind_door_dir_room( &world.zone[cur_zone].room[cur_room], door->dir ) );
                         add_door( &world.zone[cur_zone].room[cur_room], myodir, &world.zone[j].room[k], myoodir );
                         rehash_world( &world );
                         udisp( 4 );  /* Update the door-picker */
                         udisp( 3 );
                         udisp( 5 );
                         udisp( 8 );
                         udisp( 9 );
                         udisp( 10 );
                         udisp( 17 );
                         udisp( 23 );
                         udisp( 24 );
                         }
                       cur_dir = -1;
                       odir = -1;
                       }
                     edmode = EM_NORM;
                     }
                   /* Just select a room (EM_NORM) */
                   else{
                     if( msel_list.num_sel > 0 ){
                       if( find_msel_item( &msel_list, j, k ) == NULL ){
                         del_msel_list( &msel_list );
                         cur_zone = j;
                         cur_room = k;
                         }
                       else{
                         cur_msel = msel_list.base;
                         do{
                           cur_msel->x = world.zone[cur_msel->hi_ind].room[cur_msel->lo_ind].x - world.zone[j].room[k].x;
                           cur_msel->y = world.zone[cur_msel->hi_ind].room[cur_msel->lo_ind].y - world.zone[j].room[k].y;
                           cur_msel = cur_msel->next;
                           } while( cur_msel != msel_list.base );
                         }
                       }
                     else{
                       cur_zone = j;
                       cur_room = k;
                       }
                     selmade = -1;
                     }
   
                   udisp( 4 );  /* Update the door-picker */
                   udisp( 3 );
                   udisp( 5 );
                   udisp( 8 );
                   udisp( 9 );
                   udisp( 10 );
                   udisp( 17 );
                   udisp( 23 );
                   udisp( 24 );
   
                   if( (mouse_b & 1) && (selmade) ){
                     get_mouse_mickeys( &x, &y );
                     while( mouse_b & 1 ){
                       get_mouse_mickeys( &x, &y );

                       if( mouse_x < d->x ){
                         d->d1 += 3;
                         x = 1;
                         }
                       else if( mouse_x > d->x+d->w ){
                         d->d1 -= 3;
                         x = 1;
                         }
                       if( mouse_y < d->y ){
                         d->d2 += 3;
                         x = 1;
                         }
                       else if( mouse_y > d->y+d->h ){
                         d->d2 -= 3;
                         x = 1;
                         }

                       if( x != 0 || y != 0 ){
                         x = mouse_x-d->x-1 - d->w/2 - d->d1;
                         y = mouse_y-d->y-1 - d->h/2 - d->d2;

                         if( x < 0 )
                           x = (int)(x/(float)(GS)-.5);
                         else
                           x = (int)(x/(float)(GS)+.5);
     
                         if( y < 0 )
                           y = (int)(y/(float)(GS)-.5);
                         else
                           y = (int)(y/(float)(GS)+.5);

                         if( msel_list.num_sel ){
                           cur_msel = msel_list.base;
                           do{
                             world.zone[cur_msel->hi_ind].room[cur_msel->lo_ind].x = x + cur_msel->x;
                             world.zone[cur_msel->hi_ind].room[cur_msel->lo_ind].y = y + cur_msel->y;
                             cur_msel = cur_msel->next;
                             } while( cur_msel != msel_list.base );
                           }
                         else{
                           world.zone[cur_zone].room[cur_room].x = x;
                           world.zone[cur_zone].room[cur_room].y = y;
                           }

                         udisp( 5 );
                         }
                       }
     
                     unscare_mouse();
                     }
                   else if( mouse_b & 2 ){
                     if( cur_room < 0 )
                       menu_room[1].flags |= D_DISABLED;
                     else
                       menu_room[1].flags &= ~D_DISABLED;
                     do_menu( menu_room, mouse_x, mouse_y );
                     udisp( 4 );  /* Update the door-picker */
                     udisp( 3 );
                     udisp( 5 );
                     udisp( 8 );
                     udisp( 9 );
                     udisp( 10 );
                     udisp( 17 );
                     udisp( 23 );
                     udisp( 24 );
                     }
                   break;
                   }
                 }
              }
           if( !selmade ){
             del_msel_list( &msel_list );
             cur_room = -1;
             edmode = 0;
             cur_dir = -1;

             udisp( 4 );  /* Update the door-picker */
             udisp( 3 );
             udisp( 5 );
             udisp( 10 );
             udisp( 17 );
             udisp( 23 );
             udisp( 24 );

/* Code to move around the map with mouse-draggin' */
             if( mouse_b & 1 ){
               get_mouse_mickeys( &x, &y );
               scare_mouse();
               while( mouse_b & 1 ){
                 get_mouse_mickeys( &x, &y );
                 if( x != 0 || y != 0 ){
                   d->d1 += x;
                   d->d2 += y;
                   udisp( 5 );
                   }
                 }
               unscare_mouse();
               }
/* End scroll code */
             else if( mouse_b & 2 ){
               x = mouse_x;
               y = mouse_y;
               if( board.data )
                 menu_no_room[4].flags &= ~D_DISABLED;
               else
                 menu_no_room[4].flags |= D_DISABLED;

               switch( do_menu( menu_no_room, mouse_x, mouse_y ) ){
                 case 0:
                      x = x-d->x-1 - d->w/2 - d->d1;
                      y = y-d->y-1 - d->h/2 - d->d2;
  
                      if( x < 0 )
                        x = (int)(x/(float)(GS)-.5);
                      else
                        x = (int)(x/(float)(GS)+.5);
  
                      if( y < 0 )
                        y = (int)(y/(float)(GS)-.5);
                      else
                        y = (int)(y/(float)(GS)+.5);

                      add_room( &world.zone[cur_zone], x, y, cur_layer );

                      udisp( 5 );
                      break;

                 case 1:
                      x = x-d->x-1 - d->w/2 - d->d1;
                      y = y-d->y-1 - d->h/2 - d->d2;
  
                      if( x < 0 )
                        x = (int)(x/(float)(GS)-.5);
                      else
                        x = (int)(x/(float)(GS)+.5);
  
                      if( y < 0 )
                        y = (int)(y/(float)(GS)-.5);
                      else
                        y = (int)(y/(float)(GS)+.5);

                      k = add_tag( &world.zone[cur_zone], x, y, cur_layer );
                      tag_prop( k );

                      udisp( 5 );
                      break;

                 case 2:
                      d->d1 = 0;
                      d->d2 = 0;
                      udisp( 5 );
                      break;

                 case 4:
                      k = paste_board_to_zone( &board, &world.zone[cur_zone] );
                      world.zone[cur_zone].room[k].x = x-d->x-1 - d->w/2 - d->d1;
                      world.zone[cur_zone].room[k].y = y-d->y-1 - d->h/2 - d->d2;
  
                      if( world.zone[cur_zone].room[k].x < 0 )
                        world.zone[cur_zone].room[k].x = (int)(world.zone[cur_zone].room[k].x/(float)(GS)-.5);
                      else
                        world.zone[cur_zone].room[k].x = (int)(world.zone[cur_zone].room[k].x/(float)(GS)+.5);
  
                      if( world.zone[cur_zone].room[k].y < 0 )
                        world.zone[cur_zone].room[k].y = (int)(world.zone[cur_zone].room[k].y/(float)(GS)-.5);
                      else
                        world.zone[cur_zone].room[k].y = (int)(world.zone[cur_zone].room[k].y/(float)(GS)+.5);

                      world.zone[cur_zone].room[k].z = cur_layer;
                      break;
                 }
               udisp( 4 );  /* Update the door-picker */
               udisp( 3 );
               udisp( 5 );
               udisp( 8 );
               udisp( 9 );
               udisp( 10 );
               udisp( 17 );
               udisp( 23 );
               udisp( 24 );
               }
             }
           break;
      }

    return ret;
}

char *stype_lister(int index, int *list_size)
{
    static char tmp[42]="";

    if( index < 0 ){
      *list_size = 10;
      return "";
      }

    if( cur_room > -1 ){
      tmp[41] = '\0';
      strncpy( &tmp[1], stype_list[index], 40 );
      if( index == world.zone[cur_zone].room[cur_room].stype ){
        tmp[0] = '';
        }
      else{
        tmp[0] = ' ';
        }
      return tmp;
      }

    return stype_list[index];
}

int stype_list_proc( int msg, DIALOG *d, int c )
{
    int ret, mmb;

    mmb = mouse_b;

    ret = d_list_proc( msg, d, c );

    if( cur_room > -1 ){
      if( (D_DISABLED&d->flags) ){
        d->flags = d->flags&(~(D_DISABLED));
        udisp( 9 );
        }

      if( msg == MSG_USER ){
        d->d1 = world.zone[cur_zone].room[cur_room].stype;
        }

      if( msg == MSG_DCLICK ){
        world.zone[cur_zone].room[cur_room].stype = d->d1;
        udisp( 5 );
        udisp( 9 );
        }

      if( msg == MSG_CLICK ){
        if( mmb & 2 ){
          switch( do_menu( stype_menu, mouse_x, mouse_y ) ){
            case 0:
                 set_stcol( d->d1, ColorPicker( get_stcol( d->d1 ) ) );
                 ret = D_REDRAW;
                 break;
            }
          }
        }
      }
    else{
      if( !(D_DISABLED&d->flags) ){
        d->flags = d->flags|D_DISABLED;
        udisp( 9 );
        }
      }

    return ret;
}

char *zone_lister( int index, int *list_size )
{
    static char tmp[42];

    if( index < 0 ){
      *list_size = world.num_zones;
      return "";
      }

    tmp[41] = '\0';
    strncpy( &tmp[1], world.zone[index].name, 40 );
    if( index == cur_zone ){
      tmp[0] = '';
      }
    else{
      tmp[0] = ' ';
      }

    return tmp;
}

int zone_list_proc( int msg, DIALOG *d, int c )
{
    int ret, mmb;

    mmb = mouse_b;

    ret = d_list_proc( msg, d, c );

    if( msg == MSG_CLICK ){
      if( world.num_zones < 2 ){
        menu_zone_list[3].flags |= D_DISABLED;
        }
      else{
        menu_zone_list[3].flags &= ~D_DISABLED;
        }
      if( cur_room > -1 && cur_zone != d->d1 ){
        menu_zone_list[4].flags &= ~D_DISABLED;
        }
      else{
        menu_zone_list[4].flags |= D_DISABLED;
        }
      if( mmb & 2 ){
        switch( do_menu( menu_zone_list, mouse_x, mouse_y ) ){
          case 0:
               ret = add_zone( &world );
               if( strcmp( username, "Not Registered" ) )
                 strcpy( world.zone[ret].author, username );
               do_zone_prop_dlg( FALSE, ret );
               return D_REDRAW;
               break;

          case 1:
               cur_zone = d->d1;
               cur_room = -1;
               udisp( 17 );
               udisp( 5 );
               break;

          case 2:
               do_zone_prop_dlg( TRUE, d->d1 );
               return D_REDRAW;
               break;

          case 3:
               del_zone( &world, d->d1 );
               if( cur_zone == d->d1 || cur_zone == world.num_zones )
                 cur_zone--;
               if( cur_zone < 0 )
                 cur_zone = 0;
               return D_REDRAW;
               break;

          case 4:
               cur_room = move_room_to_zone( &world.zone[cur_zone], cur_room, &world.zone[d->d1] );
               cur_zone = d->d1;
               return D_REDRAW;
               break;
          }
        }
      }
    else if( msg == MSG_DCLICK ){
      cur_zone = d->d1;
      cur_room = -1;
      udisp( 17 );
      udisp( 5 );
      }

    return ret;
}

char *rexd_lister( int index, int *list_size )
{
    if( index < 0 ){
      if( cur_room > -1 )
        *list_size = world.zone[cur_zone].room[cur_room].num_exd;
      else
        *list_size = 0;
      return "";
      }

    return world.zone[cur_zone].room[cur_room].exd[index].keywords;
}

void do_rexd_prop_dlg( int index )
{
    rexd_prop_dlg[3].dp = world.zone[cur_zone].room[cur_room].exd[index].keywords;
    rexd_prop_dlg[5].dp = world.zone[cur_zone].room[cur_room].exd[index].desc;
    do_dialog( rexd_prop_dlg, 3 );
    rexd_prop_dlg[3].dp = NULL;
    rexd_prop_dlg[5].dp = NULL;
}

int rexd_list_proc( int msg, DIALOG *d, int c )
{
    int ret, mmb;

    mmb = mouse_b;

    ret = d_list_proc( msg, d, c );

    if( cur_room > -1 ){
      if( (D_DISABLED&d->flags) ){
        d->flags = d->flags&(~(D_DISABLED));
        d->proc( MSG_DRAW, d, 0 );
        }

      if( msg == MSG_DCLICK ){
        world.zone[cur_zone].room[cur_room].stype = d->d1;
        d->proc( MSG_DRAW, d, 0 );
        }

      if( msg == MSG_CLICK ){
        if( world.zone[cur_zone].room[cur_room].num_exd < 1 ){
          rexd_menu[1].flags |= D_DISABLED;
          rexd_menu[2].flags |= D_DISABLED;
          }
        else{
          rexd_menu[1].flags &= ~D_DISABLED;
          rexd_menu[2].flags &= ~D_DISABLED;
          }
        if( mmb & 2 ){
          if( world.zone[cur_zone].room[cur_room].num_exd < 1 ){
            rexd_menu[1].flags |= D_DISABLED;
            rexd_menu[2].flags |= D_DISABLED;
            }
          else{
            rexd_menu[1].flags &= ~D_DISABLED;
            rexd_menu[2].flags &= ~D_DISABLED;
            }
          switch( do_menu( rexd_menu, mouse_x, mouse_y ) ){
            case 0:
                 do_rexd_prop_dlg( add_room_exd( &world.zone[cur_zone].room[cur_room] ) );
                 return D_REDRAW;
                 break;

            case 1:
                 do_rexd_prop_dlg( d->d1 );
                 return D_REDRAW;
                 break;

            case 2:
                 del_room_exd( &world.zone[cur_zone].room[cur_room], d->d1 );
                 d->proc( MSG_DRAW, d, 0 );
                 break;
            }
          }
        }
      }
    else{
      if( !(D_DISABLED&d->flags) ){
        d->flags = d->flags|D_DISABLED;
        d->proc( MSG_DRAW, d, 0 );
        }
      }

    return ret;
}

char *zrbv_lister(int index, int *list_size)
{
    static char tmp[42]="";

    if( index < 0 ){
      *list_size = 11;
      return rbv_list[0];
      }

    if( cur_zone > -1 ){
      tmp[41] = '\0';
      strncpy( &tmp[1], rbv_list[index], 40 );
      if( ((1<<index)&world.zone[cur_zone].rbv) ){
        tmp[0] = '';
        }
      else{
        tmp[0] = ' ';
        }
      return tmp;
      }

    return rbv_list[index];
}

int zrbv_list_proc( int msg, DIALOG *d, int c )
{
    int ret = d_list_proc( msg, d, c );
//    int j;

    if( cur_zone > -1 ){
      if( (D_DISABLED&d->flags) ){
        d->flags = d->flags&(~(D_DISABLED));
        d->proc( MSG_DRAW, d, 0 );
        }

      if( msg == MSG_USER ){
        }
  
      if( msg == MSG_DCLICK ){
        if( ((1<<d->d1)&world.zone[cur_zone].rbv) ){
          world.zone[cur_zone].rbv = world.zone[cur_zone].rbv&(~(1<<d->d1));
          }
        else{
          world.zone[cur_zone].rbv = world.zone[cur_zone].rbv|(1<<d->d1);
          }
        d->proc( MSG_DRAW, d, 0 );
        }
      }
    else{
      if( !(D_DISABLED&d->flags) ){
        d->flags = d->flags|D_DISABLED;
        d->proc( MSG_DRAW, d, 0 );
        }
      }

    return ret;
}

char *zstype_lister(int index, int *list_size)
{
    static char tmp[42]="";

    if( index < 0 ){
      *list_size = 10;
      return "";
      }

    if( cur_zone > -1 ){
      tmp[41] = '\0';
      strncpy( &tmp[1], stype_list[index], 40 );
      if( index == world.zone[cur_zone].stype ){
        tmp[0] = '';
        }
      else{
        tmp[0] = ' ';
        }
      return tmp;
      }

    return stype_list[index];
}

int zstype_list_proc( int msg, DIALOG *d, int c )
{
    int ret, mmb;

    mmb = mouse_b;

    ret = d_list_proc( msg, d, c );

    if( cur_zone > -1 ){
      if( (D_DISABLED&d->flags) ){
        d->flags = d->flags&(~(D_DISABLED));
        d->proc( MSG_DRAW, d, 0 );
        }

      if( msg == MSG_USER ){
        d->d1 = world.zone[cur_zone].stype;
        }

      if( msg == MSG_DCLICK ){
        world.zone[cur_zone].stype = d->d1;
        d->proc( MSG_DRAW, d, 0 );
        }

      if( msg == MSG_CLICK ){
        if( mmb & 2 ){
          switch( do_menu( stype_menu, mouse_x, mouse_y ) ){
            case 0:
                 set_stcol( d->d1, ColorPicker( get_stcol( d->d1 ) ) );
                 ret = D_REDRAW;
                 break;
            }
          }
        }
      }
    else{
      if( !(D_DISABLED&d->flags) ){
        d->flags = d->flags|D_DISABLED;
        d->proc( MSG_DRAW, d, 0 );
        }
      }

    return ret;
}

int hue_selector_proc( int msg, DIALOG *d, int c )
{
    int ret;

    if( msg == MSG_DRAW ){
      room3d( screen, d->x, d->y, d->w, d->h, makecol( 255, 255, 255 ), makecol( 115, 115, 115 ), d->d1 );
      ret = D_O_K;
      }
    else{
      ret = d_button_proc( msg, d, c );
      if( ret == D_EXIT ){
        d->d1 = ColorPicker( d->d1 );
        ret = D_REDRAW;
        }
      }

    return ret;
}

int reset_mode_drop_proc( int msg, DIALOG *d, int c )
{
    int ret = d_button_proc( msg, d, c );

    if( ret == D_EXIT ){
      ret = do_menu( reset_mode_menu, d->x+5, d->y+d->h );
      if( ret > -1 ){
        strcpy( zone_prop_dlg[9].dp, reset_mode_menu[ret].text );
        world.zone[cur_zone].reset_mode = ret;
        }
      ret = D_REDRAW;
      }

    return ret;
}

int do_zone_prop_dlg( char edit, int index )
{
    char *str[2]={"Create a new zone",
                  "Modify a zone\'s properties"};
    char str2[50];
    int old_cur_zone, ret, vnumtemp;
    int j;

    vnumtemp = world.zone[index].vnum;

    if( edit ){
      zone_prop_dlg[1].dp = str[1];
      zone_prop_dlg[7].proc = d_text_proc;
      zone_prop_dlg[7].bg = zone_prop_dlg[6].bg;
      }
    else{
      zone_prop_dlg[1].dp = str[0];
      zone_prop_dlg[7].proc = d_edit_proc;
      zone_prop_dlg[7].bg = zone_prop_dlg[5].bg;
      }

    zone_prop_dlg[3].dp = world.zone[index].name;
    zone_prop_dlg[5].dp = world.zone[index].author;

    sprintf( zone_prop_dlg[7].dp, "%d", world.zone[index].vnum );

    strcpy( zone_prop_dlg[9].dp, reset_mode_menu[world.zone[index].reset_mode].text );

    sprintf( zone_prop_dlg[11].dp, "%d", world.zone[index].life_span );

    zone_prop_dlg[13].d1 = world.zone[index].tint;

    old_cur_zone = cur_zone;
    cur_zone = index;
    ret = do_dialog( zone_prop_dlg, 1 );
    cur_zone = old_cur_zone;

    world.zone[index].tint = zone_prop_dlg[13].d1;

    world.zone[index].vnum = atoi( zone_prop_dlg[7].dp );
    if( world.zone[index].vnum < 0 ){
      alert("Error creating zone!", "You can't have a negative VNUM!!!!", NULL, "Yeah, I guess...", NULL, NULL, NULL );
      world.zone[index].vnum = vnumtemp;
      }
    else{
      if( world.last_zone_vnum < world.zone[index].vnum ){
        world.last_zone_vnum = world.zone[index].vnum;
        }
      }

    world.zone[index].life_span = atoi( zone_prop_dlg[11].dp );

    for( j = 0; j < world.num_zones; j++ ){
       if( index != j &&
           world.zone[index].vnum == world.zone[j].vnum ){
         sprintf( str2, "Zone vnum %d exists, this zone will be set to %d instead.", world.zone[index].vnum, vnumtemp );
         alert("Error creating zone!", str2, NULL, "Well, Alright...", NULL, NULL, NULL );
         world.zone[index].vnum = vnumtemp;
         break;
         }
       }

    sort_zones( &world );

    return ret;
}

int d_splash_proc( int msg, DIALOG *d, int c )
{
    BITMAP *bm, *bm2;

    if( msg == MSG_DRAW && d->d1 == 0 ){
      c = 0;
      d->d1 = -1;
      bm = dat[1].dat;
      if( bm ){
        bm2 = create_bitmap( bm->w, bm->h );
        blit( screen, bm2, (SCREEN_W-bm->w)/2, (SCREEN_H-bm->h)/2, 0, 0, bm->w, bm->h );
        blit( bm, screen, 0, 0, (SCREEN_W-bm->w)/2, (SCREEN_H-bm->h)/2, bm->w, bm->h );
        while( !keypressed() && !mouse_b );
        blit( bm2, screen, 0, 0, (SCREEN_W-bm->w)/2, (SCREEN_H-bm->h)/2, bm->w, bm->h );
        destroy_bitmap( bm2 );
        }

      if( strcmp( username, "Not Registered" ) == 0 ){
        do_registrar_dlg();
        return D_REDRAW;
        }
      }

    return D_O_K;
}

int d_draggy_proc( int msg, DIALOG *d, int c )
{
    int x;

    c = 0;

    switch( msg ){
      case MSG_DRAW:
           triangle( screen, d->x, d->y, d->x+d->w, d->y, d->x+d->w/2, d->y+d->h, d->fg );
           break;

      case MSG_CLICK:
           x = mouse_x;
           while( mouse_b ){
             if( x != mouse_x && mouse_x > d->d1 && mouse_x < d->d2 ){
               x = mouse_x+6;
               main_dlg[5].x = x;
               main_dlg[5].w = 628-x;
               main_dlg[8].w = x-11;
               main_dlg[9].w = x-11;
               main_dlg[17].w = x-11;
               main_dlg[23].w = x-11;
               main_dlg[24].w = x-11;
               scare_mouse();
               triangle( screen, d->x, d->y, d->x+d->w, d->y, d->x+d->w/2, d->y+d->h, d->bg );
               d->x = mouse_x;
               triangle( screen, d->x, d->y, d->x+d->w, d->y, d->x+d->w/2, d->y+d->h, d->fg );
               main_dlg[5].proc( MSG_DRAW, &main_dlg[5], 0 );
               main_dlg[8].proc( MSG_DRAW, &main_dlg[8], 0 );
               main_dlg[9].proc( MSG_DRAW, &main_dlg[9], 0 );
               main_dlg[17].proc( MSG_DRAW, &main_dlg[17], 0 );
               main_dlg[23].proc( MSG_DRAW, &main_dlg[23], 0 );
               main_dlg[24].proc( MSG_DRAW, &main_dlg[24], 0 );
               unscare_mouse();
               }
             }
           return D_REDRAW;
           break;
      }

    return D_O_K;
}

int do_splash()
{
    main_dlg[37].d1 = 0;
    return D_REDRAW;
}

int do_refresh()
{
    remove_mouse();
    remove_timer();
    remove_keyboard();
    install_keyboard();
    install_timer();
    install_mouse();

    show_mouse( screen );

    return D_REDRAW;
}

int dtype_unrestr()
{
    menu_dtype[0].flags |= D_SELECTED;
    menu_dtype[1].flags &= ~D_SELECTED;
    menu_dtype[2].flags &= ~D_SELECTED;
    ((DOOR *)menu_door[0].dp)->typea = 0;
    ((DOOR *)menu_door[0].dp)->other->typea = 0;

    edmode = EM_NORM;
    cur_dir = odir = -1;

    return D_O_K;
}

int dtype_normal()
{
    menu_dtype[0].flags &= ~D_SELECTED;
    menu_dtype[1].flags |= D_SELECTED;
    menu_dtype[2].flags &= ~D_SELECTED;
    ((DOOR *)menu_door[0].dp)->typea = 1;
    ((DOOR *)menu_door[0].dp)->other->typea = 1;

    edmode = EM_NORM;
    cur_dir = odir = -1;

    return D_O_K;
}

int dtype_pickpro()
{
    menu_dtype[0].flags &= ~D_SELECTED;
    menu_dtype[1].flags &= ~D_SELECTED;
    menu_dtype[2].flags |= D_SELECTED;
    ((DOOR *)menu_door[0].dp)->typea = 2;
    ((DOOR *)menu_door[0].dp)->other->typea = 2;

    edmode = EM_NORM;
    cur_dir = odir = -1;

    return D_O_K;
}

int dstate_opened()
{
    menu_dstate[0].flags |= D_SELECTED;
    menu_dstate[1].flags &= ~D_SELECTED;
    menu_dstate[2].flags &= ~D_SELECTED;
    ((DOOR *)menu_door[0].dp)->state = 0;
    ((DOOR *)menu_door[0].dp)->other->state = 0;

    edmode = EM_NORM;
    cur_dir = odir = -1;

    return D_O_K;
}

int dstate_closed()
{
    menu_dstate[0].flags &= ~D_SELECTED;
    menu_dstate[1].flags |= D_SELECTED;
    menu_dstate[2].flags &= ~D_SELECTED;
    ((DOOR *)menu_door[0].dp)->state = 1;
    ((DOOR *)menu_door[0].dp)->other->state = 1;

    edmode = EM_NORM;
    cur_dir = odir = -1;

    return D_O_K;
}

int dstate_locked()
{
    menu_dstate[0].flags &= ~D_SELECTED;
    menu_dstate[1].flags &= ~D_SELECTED;
    menu_dstate[2].flags |= D_SELECTED;
    ((DOOR *)menu_door[0].dp)->state = 2;
    ((DOOR *)menu_door[0].dp)->other->state = 2;

    edmode = EM_NORM;
    cur_dir = odir = -1;

    return D_O_K;
}

int do_door_key_picker_dlg()
{
    if( world.zone[cur_zone].room[cur_room].door[cur_dir].key == -1 )
      door_key_picker_dlg[3].flags |= D_SELECTED;
    else
      door_key_picker_dlg[3].flags &= ~D_SELECTED;

    do_dialog( door_key_picker_dlg, 2 );

    if( door_key_picker_dlg[3].flags & D_SELECTED )
      world.zone[cur_zone].room[cur_room].door[cur_dir].key = -1;

    return D_REDRAW;
}

int d_door_key_picker_proc( int msg, DIALOG *d, int c )
{
    int ret;

    if( msg == MSG_DRAW ){
      d->dp = find_object_vnum_zone( &world.zone[cur_zone], world.zone[cur_zone].room[cur_room].door[cur_dir].key )->short_desc;
      }

    ret = d_droplistbutton_proc( msg, d, c );

    if( ret == D_REDRAW ){
      world.zone[cur_zone].room[cur_room].door[cur_dir].key = find_object_short_desc_zone( &world.zone[cur_zone], d->dp )->vnum;
      }

    return ret;
}

int do_spell_check()
{
    set_gfx_mode( GFX_TEXT, 0, 0, 0, 0 );
    _set_screen_lines( 50 );
    remove_keyboard();
    spell_check_world( &world );
    install_keyboard();
    set_color_depth( 16 );
    set_gfx_mode( GFX_AUTODETECT, 640, 480, 0, 0 );
    show_mouse( screen );
    set_trans_blender( 128, 128, 128, 128 );
    set_colors( NULL );

    return D_REDRAW;
}

int dtype_twoway()
{
    menu_dtype[4].flags |= D_SELECTED;
    menu_dtype[5].flags &= ~D_SELECTED;
    menu_dtype[6].flags &= ~D_SELECTED;
    ((DOOR *)menu_door[0].dp)->typeb &= ~D_CANT_LEAVE;
    ((DOOR *)menu_door[0].dp)->other->typeb &= ~D_CANT_LEAVE;

    return D_O_K;
}

int dtype_oneout()
{
    menu_dtype[4].flags &= ~D_SELECTED;
    menu_dtype[5].flags |= D_SELECTED;
    menu_dtype[6].flags &= ~D_SELECTED;
    ((DOOR *)menu_door[0].dp)->typeb &= ~D_CANT_LEAVE;
    ((DOOR *)menu_door[0].dp)->other->typeb |= D_CANT_LEAVE;

    return D_O_K;
}

int dtype_onein()
{
    menu_dtype[4].flags &= ~D_SELECTED;
    menu_dtype[5].flags &= ~D_SELECTED;
    menu_dtype[6].flags |= D_SELECTED;
    ((DOOR *)menu_door[0].dp)->typeb |= D_CANT_LEAVE;
    ((DOOR *)menu_door[0].dp)->other->typeb &= ~D_CANT_LEAVE;

    return D_O_K;
}

int wrld_bmp_export()
{
    int j, k;
    int minx=0, miny=0, minz=0;
    int maxx=0, maxy=0, maxz=0;
    BITMAP *bm;
    char str[50];

    for( j = 0; j < world.num_zones; j++ ){
       for( k = 0; k < world.zone[j].num_rooms; k++ ){
          if( world.zone[j].room[k].x < minx )
            minx = world.zone[j].room[k].x;
          if( world.zone[j].room[k].x > maxx )
            maxx = world.zone[j].room[k].x;

          if( world.zone[j].room[k].y < miny )
            miny = world.zone[j].room[k].y;
          if( world.zone[j].room[k].y > maxy )
            maxy = world.zone[j].room[k].y;

          if( world.zone[j].room[k].z < minz )
            minz = world.zone[j].room[k].z;
          if( world.zone[j].room[k].z > maxz )
            maxz = world.zone[j].room[k].z;
          }
       }

    bm = create_bitmap( (maxx-minx)*GS+(4*GS), (maxy-miny)*GS+(4*GS) );

    for( j = minz; j <= maxz; j++ ){
       clear_to_color( bm, gui_bg_color );
       draw_map( &world, bm, -(maxx+minx)/2*GS, -(maxy+miny)/2*GS, j, DMODE_SINGLE, (void *)(-1), (void *)(-1), DRAW_COASTERS|DRAW_TRANS ); //(minx-maxx)/2*GS, (miny-maxy)/2*GS,
       sprintf( str, "export_%d.bmp", j );
       save_bitmap( str, bm, NULL );
       }

    destroy_bitmap( bm );

    return D_REDRAW;
}

int wrld_import()
{
    destroy_world( &world );
    new_world( &world );

    set_gfx_mode( GFX_TEXT, 0, 0, 0, 0 );
    _set_screen_lines( 80 );

    import_circle_world( &world, "import\\" );

    set_color_depth( 16 );
    set_gfx_mode( GFX_AUTODETECT, 640, 480, 0, 0 );
    show_mouse( screen );
    set_trans_blender( 128, 128, 128, 128 );
    set_colors( NULL );

    return D_REDRAW;
}

int copy_room()
{
    copy_room_to_board( &world.zone[cur_zone].room[cur_room], &board );

    return D_O_K;
}

int do_server_clean()
{
    return D_O_K;
}

int do_world_run()
{
    char path[512];
    int j, k, haszero=FALSE;

    for( j = 0; j < world.num_zones; j++ ){
       if( world.zone[j].vnum == 0 ){
         for( k = 0; k < world.zone[j].num_rooms; k++ ){
            if( world.zone[j].room[k].vnum == 0 ){
              haszero = TRUE;
              break;
              }
            }
         }
       }

    if( !haszero ){
      alert( "You don't have a zero room, this is necesary to run the windows",
             "version of the YFMud server.  The zero room needs to be in zone zero and",
             "needs a vnum of zero.",
             "I'll check it out", NULL,
             NULL, NULL );
      return D_REDRAW;
      }

    memset( path, 0, 512 );
    getwd( path );

    if(!__file_exists("server\\mud.exe")){
      alert( "You don't seem to actually have the server loaded.",
             "You can download it from http://www.mud.yf-soft.com",
             "This is required to run yout world.",
             "Nevermind...", NULL,
             NULL, NULL );
      return D_REDRAW;
      }
    else{
      strcat( path, "\\server\\lib\\world" );
      }

    mkdir( path, S_IWUSR );

    export_world( path, &world );

    printf("Starting Server...\n");

    chdir("server");
    system("start /m mud.exe");
    chdir("..");

    printf("Starting Telnet Client...\n");
    system("start \"C:\\Program Files\\Token 2\\Token2.exe\"");

    printf("Press any key to return to YFMudEd.\n\n");

    while( keypressed() )
      readkey();
    readkey();

    set_color_depth( 16 );
    set_gfx_mode( GFX_AUTODETECT, 640, 480, 0, 0 );
    show_mouse( screen );
    set_trans_blender( 128, 128, 128, 128 );
    set_colors( NULL );

    return do_refresh();
}

int quick_do_door_orient()
{
    int j, cur_door;
    DOOR *odoor;

    if( cur_zone < 0 || cur_room < 0 || cur_dir < 0 )
      return D_O_K;

    cur_door = ifind_door_dir_room( &world.zone[cur_zone].room[cur_room], cur_dir );

    for( j = 0; j < ND; j++ ){
       odoor = find_door_dir_room( world.zone[cur_zone].room[cur_room].door[cur_door].other->parent, (j+world.zone[cur_zone].room[cur_room].door[cur_door].other->dir)%ND );
       if( odoor == NULL ){
         world.zone[cur_zone].room[cur_room].door[cur_door].other->dir = (j+world.zone[cur_zone].room[cur_room].door[cur_door].other->dir)%ND;
         break;
         }
       }
    edmode = EM_NORM;
    cur_dir = odir = -1;

    udisp( 4 );
    udisp( 5 );
    udisp( 10 );

    return D_O_K;
}
