#include <allegro.h>      /* Allegro rules!!! */
#include <string.h>
#include <stdio.h>
#include "edop.h"
#include "ymw.h"
#include "FileIO.h"
#include "mem.h"
#include "gfxhelp.h"
#include "ColorPicker.h"
#include "MobileDialog.h"
#include "genproc.h"

#include "lists.h"

int mob_ed_refresher( int msg, DIALOG *d, int c );
char *mobile_lister( int index, int *list_size );
int mobile_list_proc( int msg, DIALOG *d, int c );
int mob_shdesc_proc( int msg, DIALOG *d, int c );
char *mobile_act_lister( int index, int *list_size );
int mobile_act_list_proc( int msg, DIALOG *d, int c );
char *mobile_aff_lister( int index, int *list_size );
int mobile_aff_list_proc( int msg, DIALOG *d, int c );

MENU menu_mobile_list[]=
{
   /* text,             proc,           child,      flags, dp */
    { "&Create new",    NULL,           NULL,       0,     NULL },
    { "&Edit",          NULL,           NULL,       0,     NULL },
    { "&Delete",        NULL,           NULL,       0,     NULL },
    { NULL,             NULL,           NULL,       0,     NULL }
};

MENU pos_menu[]=
{
   /* text,             proc,           child,      flags, dp */
    { "Sleeping",       NULL,           NULL,       0,     NULL },
    { "Resting",        NULL,           NULL,       0,     NULL },
    { "Sitting",        NULL,           NULL,       0,     NULL },
    { "Standing",       NULL,           NULL,       0,     NULL },
    { NULL,             NULL,           NULL,       0,     NULL }
};

MENU sex_menu[]=
{
   /* text,                 proc,           child,      flags, dp */
    { "Neutral (it/its)",   NULL,           NULL,       0,     NULL },
    { "Male (he/his)",      NULL,           NULL,       0,     NULL },
    { "Female (she/hers)",  NULL,           NULL,       0,     NULL },
    { NULL,             NULL,           NULL,       0,     NULL }
};

DIALOG mob_ed_dlg[]=
{
     /* proc,                    x,   y,   w,   h,   fg,  bg,  key, flags,  d1,         d2, dp,                      dp2,      dp3 */
/*00*/{ mob_ed_refresher,        0,   0,   0,   0,   0,   0,   0,   0,      0,          0,  NULL,                    NULL,     NULL },
/*01*/{ d_shadow_box_proc,       0,   0,   540, 365, CTX, CFG, 0,   0,      0,          0,  NULL,                    NULL,     NULL },
/*02*/{ d_ctext_proc,            80,  5,   0,   8,   CTX, CFG, 0,   0,      0,          0,  "Mobiles",               NULL,     NULL },
/*03*/{ mobile_list_proc,        5,   14,  160, 62,  CTX, CFG, 0,   0,      0,          0,  mobile_lister,           NULL,     NULL },
/*04*/{ d_text_proc,             304, 5,   96,  8,   CTX, CFG, 0,   0,      0,          0,  "Descriptions",          NULL,     NULL },
/*05*/{ d_text_proc,             170, 14,  88,  8,   CTX, CFG, 0,   0,      0,          0,  "Short:",                NULL,     NULL },
/*06*/{ mob_shdesc_proc,         265, 14,  267, 8,   CTX, CBD, 0,   0,      NAMESIZE,   0,  blankstr,                NULL,     NULL },
/*07*/{ d_text_proc,             170, 23,  88,  8,   CTX, CFG, 0,   0,      0,          0,  "Long:",                 NULL,     NULL },
/*08*/{ d_edit_proc,             265, 23,  267, 8,   CTX, CBD, 0,   0,      NAMESIZE,   0,  blankstr,                NULL,     NULL },
/*09*/{ d_text_proc,             170, 32,  88,  8,   CTX, CFG, 0,   0,      0,          0,  "Keywords:",             NULL,     NULL },
/*10*/{ d_edit_proc,             265, 32,  267, 8,   CTX, CBD, 0,   0,      NAMESIZE,   0,  blankstr,                NULL,     NULL },
/*11*/{ d_text_proc,             170, 41,  88,  8,   CTX, CFG, 0,   0,      0,          0,  "Detail:",               NULL,     NULL },
/*12*/{ d_edit_proc,             265, 41,  267, 8,   CTX, CBD, 0,   0,      RDSIZE,     0,  blankstr,                NULL,     NULL },
/*13*/{ d_ctext_proc,            136, 77,  0,   8,   CTX, CFG, 0,   0,      0,          0,  "Action",                NULL,     NULL },
/*14*/{ mobile_act_list_proc,    5,   86,  262, 68,  CTX, CFG, 0,   0,      0,          0,  mobile_act_lister,       NULL,     NULL },
/*15*/{ d_ctext_proc,            402, 77,  0,   8,   CTX, CFG, 0,   0,      0,          0,  "Affection",             NULL,     NULL },
/*16*/{ mobile_aff_list_proc,    272, 86,  262, 68,  CTX, CFG, 0,   0,      0,          0,  mobile_aff_lister,       NULL,     NULL },
/*17*/{ d_text_proc,             5,   157, 88,  8,   CTX, CFG, 0,   0,      0,          0,  "Alignment:",            NULL,     NULL },
/*18*/{ d_num_edit_proc,         100, 157, 166, 8,   CTX, CBD, 0,   0,      10,         0,  "Alignment#",            NULL,     NULL },
/*19*/{ d_text_proc,             5,   166, 88,  8,   CTX, CFG, 0,   0,      0,          0,  "Level:",                NULL,     NULL },
/*20*/{ d_num_edit_proc,         100, 166, 166, 8,   CTX, CBD, 0,   0,      10,         0,  "Level#####",            NULL,     NULL },
/*21*/{ d_text_proc,             5,   175, 88,  8,   CTX, CFG, 0,   0,      0,          0,  "thac0:",                NULL,     NULL },
/*22*/{ d_num_edit_proc,         100, 175, 166, 8,   CTX, CBD, 0,   0,      10,         0,  "thac0#####",            NULL,     NULL },
/*23*/{ d_text_proc,             272, 157, 88,  8,   CTX, CFG, 0,   0,      0,          0,  "Armor Class:",          NULL,     NULL },
/*24*/{ d_num_edit_proc,         367, 157, 166, 8,   CTX, CBD, 0,   0,      10,         0,  "AC########",            NULL,     NULL },
/*25*/{ d_text_proc,             272, 166, 88,  8,   CTX, CFG, 0,   0,      0,          0,  "Gold:",                 NULL,     NULL },
/*26*/{ d_num_edit_proc,         367, 166, 166, 8,   CTX, CBD, 0,   0,      10,         0,  "Gold######",            NULL,     NULL },
/*27*/{ d_text_proc,             272, 175, 88,  8,   CTX, CFG, 0,   0,      0,          0,  "Experience:",           NULL,     NULL },
/*28*/{ d_num_edit_proc,         367, 175, 166, 8,   CTX, CBD, 0,   0,      10,         0,  "Experience",            NULL,     NULL },
/*29*/{ d_text_proc,             5,   184, 88,  8,   CTX, CFG, 0,   0,      0,          0,  "Max HP:",               NULL,     NULL },
/*30*/{ d_num_edit_proc,         100, 184, 32,  8,   CTX, CBD, 0,   0,      3,          0,  "mhpx######",            NULL,     NULL },
/*31*/{ d_text_proc,             132, 184, 24,  8,   CTX, CFG, 0,   0,      0,          0,  " d ",                   NULL,     NULL },
/*32*/{ d_num_edit_proc,         156, 184, 32,  8,   CTX, CBD, 0,   0,      3,          0,  "mhpy######",            NULL,     NULL },
/*33*/{ d_text_proc,             188, 184, 24,  8,   CTX, CFG, 0,   0,      0,          0,  " + ",                   NULL,     NULL },
/*34*/{ d_num_edit_proc,         212, 184, 32,  8,   CTX, CBD, 0,   0,      3,          0,  "mhpz######",            NULL,     NULL },
/*35*/{ d_text_proc,             272, 184, 88,  8,   CTX, CFG, 0,   0,      0,          0,  "Bare hand:",            NULL,     NULL },
/*36*/{ d_num_edit_proc,         367, 184, 32,  8,   CTX, CBD, 0,   0,      3,          0,  "bhdx######",            NULL,     NULL },
/*37*/{ d_text_proc,             399, 184, 24,  8,   CTX, CFG, 0,   0,      0,          0,  " d ",                   NULL,     NULL },
/*38*/{ d_num_edit_proc,         423, 184, 32,  8,   CTX, CBD, 0,   0,      3,          0,  "bhdy######",            NULL,     NULL },
/*39*/{ d_text_proc,             455, 184, 24,  8,   CTX, CFG, 0,   0,      0,          0,  " + ",                   NULL,     NULL },
/*40*/{ d_num_edit_proc,         479, 184, 32,  8,   CTX, CBD, 0,   0,      3,          0,  "bhdz######",            NULL,     NULL },
/*41*/{ d_text_proc,             5,   196, 88,  8,   CTX, CFG, 0,   0,      0,          0,  "Load pos:",             NULL,     NULL },
/*42*/{ d_menubutton_proc,       100, 194, 166, 12,  CTX, CFG, 0,   D_EXIT, 0,          0,  "Standing",              pos_menu, NULL },
/*43*/{ d_text_proc,             272, 196, 88,  8,   CTX, CFG, 0,   0,      0,          0,  "Def. pos:",             NULL,     NULL },
/*44*/{ d_menubutton_proc,       367, 194, 166, 12,  CTX, CFG, 0,   D_EXIT, 0,          0,  "Standing",              pos_menu, NULL },
/*45*/{ d_text_proc,             5,   210, 88,  8,   CTX, CFG, 0,   0,      0,          0,  "Sex:",                  NULL,     NULL },
/*46*/{ d_menubutton_proc,       100, 208, 166, 12,  CTX, CFG, 0,   D_EXIT, 0,          0,  "Standing",              sex_menu, NULL },

/*23*///{ d_ctext_proc,            445, 77,  0,   8,   CTX, CFG, 0,   0,      0,          0,  "Wear",                  NULL,     NULL },
/*24*///{ object_wbv_list_proc,    361, 86,  173, 68,  CTX, CFG, 0,   0,      0,          0,  object_wbv_lister,       NULL,     NULL },
/*25*///{ object_type_label,       5,   157, 192, 8,   CTX, CFG, 0,   0,      0,          0,  NULL,                    NULL,     (void *)(0) },
/*26*///{ object_type_proc,        221, 155, 192, 12,  CTX, CFG, 0,   0,      0,          0,  NULL,                    NULL,     (void *)(0) },
/*27*///{ object_type_label,       5,   171, 192, 8,   CTX, CFG, 0,   0,      0,          0,  NULL,                    NULL,     (void *)(1) },
/*28*///{ object_type_proc,        221, 169, 192, 12,  CTX, CFG, 0,   0,      0,          0,  NULL,                    NULL,     (void *)(1) },
/*29*///{ object_type_label,       5,   185, 192, 8,   CTX, CFG, 0,   0,      0,          0,  NULL,                    NULL,     (void *)(2) },
/*30*///{ object_type_proc,        221, 183, 192, 12,  CTX, CFG, 0,   0,      0,          0,  NULL,                    NULL,     (void *)(2) },
/*31*///{ object_type_label,       5,   199, 192, 8,   CTX, CFG, 0,   0,      0,          0,  NULL,                    NULL,     (void *)(3) },
/*32*///{ object_type_proc,        221, 197, 192, 12,  CTX, CFG, 0,   0,      0,          0,  NULL,                    NULL,     (void *)(3) },
/*33*///{ d_ctext_proc,            101, 211, 192, 8,   CTX, CFG, 0,   0,      0,          0,  "Descriptions:",         NULL,     NULL },
/*34*///{ obj_exd_list_proc,       5,   220, 192, 44,  CTX, CFG, 0,   0,      0,          0,  obj_exd_lister,          NULL,     NULL },
/*35*///{ d_text_proc,             202, 211, 88,  8,   CTX, CFG, 0,   0,      0,          0,  "Keywords:",             NULL,     NULL },
/*36*///{ exd_kword_edit_proc,     218, 220, 317, 8,   CTX, CBD, 0,   0,      NAMESIZE,   0,  blankstr,                NULL,     NULL },
/*37*///{ d_text_proc,             202, 229, 88,  8,   CTX, CFG, 0,   0,      0,          0,  "Description:",          NULL,     NULL },
/*38*///{ d_edit_proc,             218, 238, 317, 8,   CTX, CBD, 0,   0,      RDSIZE,     0,  blankstr,                NULL,     NULL },
/*39*///{ d_ctext_proc,            270, 267, 0,   8,   CTX, CFG, 0,   0,      0,          0,  "Object Affects",        NULL,     NULL },
/*40*///{ object_affect_list_proc, 5,   276, 530, 36,  CTX, CFG, 0,   0,      0,          0,  object_affect_lister,    NULL,     NULL },
/*41*///{ d_ctext_proc,            137, 315, 0,   8,   CTX, CFG, 0,   0,      0,          0,  "Apply to...",           NULL,     NULL },
/*42*///{ object_affects_list_proc,5,   324, 265, 36,  CTX, CFG, 0,   0,      0,          0,  object_affects_lister,   NULL,     NULL },
/*43*///{ d_ctext_proc,            407, 315, 0,   8,   CTX, CFG, 0,   0,      0,          0,  "By amount...",          NULL,     NULL },
/*44*///{ af_value_edit_proc,      275, 324, 260, 8,   CTX, CBD, 0,   0,      10,         0,  "ObjAfValue",            NULL,     NULL },
/*45*/{ d_button_proc,           405, 335, 130, 25,  CTX, CFG, 0,   D_EXIT, 0,          0,  "Return",                NULL,     NULL },
standarnd_dialog_chunks
};

int mob_ed_refresher( int msg, DIALOG *d, int c )
{
//    int j;
    d = NULL;
    c = 0;

greyer_thing_code

    if( msg == MSG_DRAW ){
      if( world.zone[cur_zone].num_mobiles <= 0 ||
          cur_mobile < 0 ){
        /* If there arn't any objects, disable everything */
        mob_ed_dlg[6].flags  |= D_DISABLED;
        mob_ed_dlg[8].flags  |= D_DISABLED;
        mob_ed_dlg[10].flags |= D_DISABLED;
        mob_ed_dlg[12].flags |= D_DISABLED;
        mob_ed_dlg[14].flags |= D_DISABLED;
        mob_ed_dlg[16].flags |= D_DISABLED;
        mob_ed_dlg[18].flags |= D_DISABLED;
        mob_ed_dlg[20].flags |= D_DISABLED;
        mob_ed_dlg[22].flags |= D_DISABLED;
        mob_ed_dlg[24].flags |= D_DISABLED;
        mob_ed_dlg[26].flags |= D_DISABLED;
        mob_ed_dlg[28].flags |= D_DISABLED;
        mob_ed_dlg[30].flags |= D_DISABLED;
        mob_ed_dlg[32].flags |= D_DISABLED;
        mob_ed_dlg[34].flags |= D_DISABLED;
        mob_ed_dlg[36].flags |= D_DISABLED;
        mob_ed_dlg[38].flags |= D_DISABLED;
        mob_ed_dlg[40].flags |= D_DISABLED;
        mob_ed_dlg[42].flags |= D_DISABLED;
        mob_ed_dlg[44].flags |= D_DISABLED;
        mob_ed_dlg[46].flags |= D_DISABLED;

        /* ...and give the text-dealies blank-strings */
        mob_ed_dlg[6].dp  = blankstr;
        strcpy( mob_ed_dlg[18].dp, "          " );
        strcpy( mob_ed_dlg[20].dp, "          " );
        strcpy( mob_ed_dlg[22].dp, "          " );
        strcpy( mob_ed_dlg[24].dp, "          " );
        strcpy( mob_ed_dlg[26].dp, "          " );
        strcpy( mob_ed_dlg[28].dp, "          " );
        strcpy( mob_ed_dlg[30].dp, "          " );
        strcpy( mob_ed_dlg[32].dp, "          " );
        strcpy( mob_ed_dlg[34].dp, "          " );
        strcpy( mob_ed_dlg[36].dp, "          " );
        strcpy( mob_ed_dlg[38].dp, "          " );
        strcpy( mob_ed_dlg[40].dp, "          " );
        mob_ed_dlg[42].dp = blankstr;
        mob_ed_dlg[44].dp = blankstr;
        mob_ed_dlg[46].dp = blankstr;
        return D_O_K;
        }
      else{
        /* This means there are objects */
        if( (mob_ed_dlg[6].flags & D_DISABLED) ){
          /* ...and that the short-desc editor is disabled */
          /* ...so we re-enable everything... */
          cur_object = 0;
          mob_ed_dlg[6].flags  &= ~D_DISABLED;
          mob_ed_dlg[8].flags  &= ~D_DISABLED;
          mob_ed_dlg[10].flags &= ~D_DISABLED;
          mob_ed_dlg[12].flags &= ~D_DISABLED;
          mob_ed_dlg[14].flags &= ~D_DISABLED;
          mob_ed_dlg[16].flags &= ~D_DISABLED;
          mob_ed_dlg[18].flags &= ~D_DISABLED;
          mob_ed_dlg[20].flags &= ~D_DISABLED;
          mob_ed_dlg[22].flags &= ~D_DISABLED;
          mob_ed_dlg[24].flags &= ~D_DISABLED;
          mob_ed_dlg[26].flags &= ~D_DISABLED;
          mob_ed_dlg[28].flags &= ~D_DISABLED;
          mob_ed_dlg[30].flags &= ~D_DISABLED;
          mob_ed_dlg[32].flags &= ~D_DISABLED;
          mob_ed_dlg[34].flags &= ~D_DISABLED;
          mob_ed_dlg[36].flags &= ~D_DISABLED;
          mob_ed_dlg[38].flags &= ~D_DISABLED;
          mob_ed_dlg[40].flags &= ~D_DISABLED;
          mob_ed_dlg[42].flags &= ~D_DISABLED;
          mob_ed_dlg[44].flags &= ~D_DISABLED;
          mob_ed_dlg[46].flags &= ~D_DISABLED;
          }
        }
      /* ...and setup the appropriate data pointers */
      mob_ed_dlg[6].dp  = world.zone[cur_zone].mobile[cur_mobile].short_desc;
      mob_ed_dlg[8].dp  = world.zone[cur_zone].mobile[cur_mobile].long_desc;
      mob_ed_dlg[10].dp = world.zone[cur_zone].mobile[cur_mobile].keywords;
      mob_ed_dlg[12].dp = world.zone[cur_zone].mobile[cur_mobile].detail_desc;
      sprintf( mob_ed_dlg[18].dp, "%d", world.zone[cur_zone].mobile[cur_mobile].alignment );
      sprintf( mob_ed_dlg[20].dp, "%d", world.zone[cur_zone].mobile[cur_mobile].level );
      sprintf( mob_ed_dlg[22].dp, "%d", world.zone[cur_zone].mobile[cur_mobile].thac0 );
      sprintf( mob_ed_dlg[24].dp, "%d", world.zone[cur_zone].mobile[cur_mobile].ac );
      sprintf( mob_ed_dlg[26].dp, "%d", world.zone[cur_zone].mobile[cur_mobile].gold );
      sprintf( mob_ed_dlg[28].dp, "%d", world.zone[cur_zone].mobile[cur_mobile].exp );
      sprintf( mob_ed_dlg[30].dp, "%d", world.zone[cur_zone].mobile[cur_mobile].mhpx );
      sprintf( mob_ed_dlg[32].dp, "%d", world.zone[cur_zone].mobile[cur_mobile].mhpy );
      sprintf( mob_ed_dlg[34].dp, "%d", world.zone[cur_zone].mobile[cur_mobile].mhpz );
      sprintf( mob_ed_dlg[36].dp, "%d", world.zone[cur_zone].mobile[cur_mobile].bhdx );
      sprintf( mob_ed_dlg[38].dp, "%d", world.zone[cur_zone].mobile[cur_mobile].bhdy );
      sprintf( mob_ed_dlg[40].dp, "%d", world.zone[cur_zone].mobile[cur_mobile].bhdz );
      mob_ed_dlg[18].dp2 = &world.zone[cur_zone].mobile[cur_mobile].alignment;
      mob_ed_dlg[20].dp2 = &world.zone[cur_zone].mobile[cur_mobile].level;
      mob_ed_dlg[22].dp2 = &world.zone[cur_zone].mobile[cur_mobile].thac0;
      mob_ed_dlg[24].dp2 = &world.zone[cur_zone].mobile[cur_mobile].ac;
      mob_ed_dlg[26].dp2 = &world.zone[cur_zone].mobile[cur_mobile].gold;
      mob_ed_dlg[28].dp2 = &world.zone[cur_zone].mobile[cur_mobile].exp;
      mob_ed_dlg[30].dp2 = &world.zone[cur_zone].mobile[cur_mobile].mhpx;
      mob_ed_dlg[32].dp2 = &world.zone[cur_zone].mobile[cur_mobile].mhpy;
      mob_ed_dlg[34].dp2 = &world.zone[cur_zone].mobile[cur_mobile].mhpz;
      mob_ed_dlg[36].dp2 = &world.zone[cur_zone].mobile[cur_mobile].bhdx;
      mob_ed_dlg[38].dp2 = &world.zone[cur_zone].mobile[cur_mobile].bhdy;
      mob_ed_dlg[40].dp2 = &world.zone[cur_zone].mobile[cur_mobile].bhdz;
      mob_ed_dlg[42].dp3 = &world.zone[cur_zone].mobile[cur_mobile].loadpos;
      mob_ed_dlg[42].dp = pos_menu[world.zone[cur_zone].mobile[cur_mobile].loadpos].text;
      mob_ed_dlg[44].dp3 = &world.zone[cur_zone].mobile[cur_mobile].defpos;
      mob_ed_dlg[44].dp = pos_menu[world.zone[cur_zone].mobile[cur_mobile].defpos].text;
      mob_ed_dlg[46].dp3 = &world.zone[cur_zone].mobile[cur_mobile].sex;
      mob_ed_dlg[46].dp = sex_menu[(int)(world.zone[cur_zone].mobile[cur_mobile].sex)].text;
      }

    return D_O_K;
}

char *mobile_lister( int index, int *list_size )
{
    static char tmp[22];

    if( index < 0 ){
      *list_size = world.zone[cur_zone].num_mobiles;
      return "";
      }

    tmp[21] = '\0';
    strncpy( &tmp[1], world.zone[cur_zone].mobile[index].short_desc, 20 );
    if( index == cur_mobile ){
      tmp[0] = '';
      }
    else{
      tmp[0] = ' ';
      }

    return tmp;
}

int mobile_list_proc( int msg, DIALOG *d, int c )
{
    int ret, mmb;

    mmb = mouse_b;

    ret = d_list_proc( msg, d, c );

    if( msg == MSG_CLICK ){
      if( mmb & 2 ){
        if( world.zone[cur_zone].num_mobiles < 1 ){
          menu_mobile_list[1].flags |= D_DISABLED;
          menu_mobile_list[2].flags |= D_DISABLED;
          }
        else{
          menu_mobile_list[1].flags &= ~D_DISABLED;
          menu_mobile_list[2].flags &= ~D_DISABLED;
          }
        switch( do_menu( menu_mobile_list, mouse_x, mouse_y ) ){
          case 0:
               cur_mobile = add_mobile( &world.zone[cur_zone] );
               d->d1 = cur_mobile;
               return D_REDRAW;
               break;

          case 1:
               cur_mobile = d->d1;
               return D_REDRAW;
               break;

          case 2:
               del_mobile( &world.zone[cur_zone], d->d1 );
               if( d->d1 >= world.zone[cur_zone].num_mobiles ){
                 d->d1 = world.zone[cur_zone].num_mobiles-1;
                 }
               return D_REDRAW;
               break;
          }
        }
      }
    else if( msg == MSG_DCLICK ){
      if( world.zone[cur_zone].num_mobiles > 0 ){
        cur_mobile = d->d1;
        }
      return D_REDRAW;
      }

    return ret;
}

int mob_shdesc_proc( int msg, DIALOG *d, int c )
{
    int ret = d_edit_proc( msg, d, c );

    if( ret == D_USED_CHAR ){
      mob_ed_dlg[3].proc( MSG_DRAW, &mob_ed_dlg[3], NULL );
      }

    return ret;
}

int mob_ed()
{
    if( world.zone[cur_zone].num_mobiles < 1 ||
        cur_mobile >= world.zone[cur_zone].num_mobiles ){
      cur_mobile = -1;
      }

    do_dialog( mob_ed_dlg, 0 );

    return D_REDRAW;
}

int mob_ed_init()
{
    set_colors( mob_ed_dlg );
    centre_dialog( mob_ed_dlg );

    return 0;
}

char *mobile_act_lister( int index, int *list_size )
{
    static char tmp[42];

    if( index < 0 ){
      *list_size = 17;
      return "";
      }

    tmp[41] = '\0';
    strncpy( &tmp[1], mobile_act_list[index].desc, 40 );
    if( ((1<<mobile_act_list[index].bitpos)&world.zone[cur_zone].mobile[cur_mobile].actbv) ){
      tmp[0] = '';
      }
    else{
      tmp[0] = ' ';
      }

    return tmp;
}

int mobile_act_list_proc( int msg, DIALOG *d, int c )
{
    int ret = d_list_proc( msg, d, c );
//    int j;

    if( cur_mobile > -1 ){
      if( (D_DISABLED&d->flags) ){
        d->flags = d->flags&(~(D_DISABLED));
        d->proc( MSG_DRAW, d, 0 );
        }

      if( msg == MSG_USER ){
        }
  
      if( msg == MSG_DCLICK ){
        if( ((1<<mobile_act_list[d->d1].bitpos)&world.zone[cur_zone].mobile[cur_mobile].actbv) ){
          world.zone[cur_zone].mobile[cur_mobile].actbv = world.zone[cur_zone].mobile[cur_mobile].actbv&(~(1<<mobile_act_list[d->d1].bitpos));
          }
        else{
          world.zone[cur_zone].mobile[cur_mobile].actbv = world.zone[cur_zone].mobile[cur_mobile].actbv|(1<<mobile_act_list[d->d1].bitpos);
          }
        d->proc( MSG_DRAW, d, 0 );
        }
      }
    else{
      if( !(D_DISABLED&d->flags) ){
        d->flags = d->flags|D_DISABLED;
        d->proc( MSG_DRAW, d, 0 );
        }
      }

    return ret;
}

char *mobile_aff_lister( int index, int *list_size )
{
    static char tmp[42];

    if( index < 0 ){
      *list_size = 15;
      return "";
      }

    tmp[41] = '\0';
    strncpy( &tmp[1], mobile_aff_list[index].desc, 40 );
    if( ((1<<mobile_aff_list[index].bitpos)&world.zone[cur_zone].mobile[cur_mobile].affbv) ){
      tmp[0] = '';
      }
    else{
      tmp[0] = ' ';
      }

    return tmp;
}

int mobile_aff_list_proc( int msg, DIALOG *d, int c )
{
    int ret = d_list_proc( msg, d, c );
//    int j;

    if( cur_mobile > -1 ){
      if( (D_DISABLED&d->flags) ){
        d->flags = d->flags&(~(D_DISABLED));
        d->proc( MSG_DRAW, d, 0 );
        }

      if( msg == MSG_USER ){
        }
  
      if( msg == MSG_DCLICK ){
        if( ((1<<mobile_aff_list[d->d1].bitpos)&world.zone[cur_zone].mobile[cur_mobile].affbv) ){
          world.zone[cur_zone].mobile[cur_mobile].affbv = world.zone[cur_zone].mobile[cur_mobile].affbv&(~(1<<mobile_aff_list[d->d1].bitpos));
          }
        else{
          world.zone[cur_zone].mobile[cur_mobile].affbv = world.zone[cur_zone].mobile[cur_mobile].affbv|(1<<mobile_aff_list[d->d1].bitpos);
          }
        d->proc( MSG_DRAW, d, 0 );
        }
      }
    else{
      if( !(D_DISABLED&d->flags) ){
        d->flags = d->flags|D_DISABLED;
        d->proc( MSG_DRAW, d, 0 );
        }
      }

    return ret;
}
